
--
-- THIS IS MACHINE GENERATED BY libformed. BE CAREFUL WITH MANUAL EDITING
--
-- Version: $Revision: 0fdbb639be0a $
--
BEGIN;

-- ------ This is static code and therefore may be put into a separate file. -------

-- Used to track the structure changes of a case
-- DROP TABLE case_structure CASCADE;

CREATE TABLE case_structure (
    id        SERIAL PRIMARY KEY NOT NULL,
    master_id int4 NOT NULL REFERENCES master_tbl(id) ON DELETE CASCADE,
    modified  boolean,
    cache     TEXT
);

-- each time a new case is created create a new entry in the strcuture table

-- DROP TRIGGER case_insert_trigger ON master_tbl;
-- DROP FUNCTION case_insert_func();

CREATE OR REPLACE FUNCTION case_insert_func() RETURNS TRIGGER AS $$
BEGIN
    INSERT INTO case_structure (master_id, modified) VALUES (NEW.id, true);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER case_insert_trigger AFTER INSERT ON master_tbl
FOR EACH ROW EXECUTE PROCEDURE case_insert_func();

-- ------ end of static code -------

-- PLPython is an untrusted language. -> Need to be postgres.
SET ROLE postgres;

-- DROP FUNCTION compute_case_structure(int4);
CREATE OR REPLACE FUNCTION compute_case_structure(case_id int4) RETURNS TEXT
AS $$

class Node(object):

    def __init__(self, name, id=None, children=[]):
        self.name = name
        self.id = id
        self.children = children

    def to_json(self, out):
        out.append('{"name":"%s","id":%d' % (self.name, self.id))
        if self.children:
            out.append(',"children":[')
            first = True
            for child in self.children:
                if first:
                    first = False
                else:
                    out.append(",")
                child.to_json(out)
            out.append("]")
        out.append("}")

    def recursive_build(self, mid, children, parent_name="master"):
        select = ("SELECT id FROM %s WHERE %s_id = %d"
                  % (self.name, parent_name, mid))
        ids = [r['id'] for r in plpy.execute(select)]
        for id in ids:
            sub_children = []
            node = Node(self.name, id, sub_children)
            name = self.name[:-4] # cut off trailing '_tbl'
            for child in self.children:
                child.recursive_build(id, sub_children, name)
            children.append(node)

TREE_STRUCTURE = Node('master_tbl', children = [
    Node('rg_netzwerk_tbl'),
    Node('rg_koop_1_tbl'),
    Node('rg_koop_2_tbl'),
    Node('rg_koop_3_tbl'),
    Node('rg_koop_4_tbl'),
    Node('rg_koop_5_tbl'),
    Node('rg_koop_bewertungen_tbl'),
    Node('rg_kjp_gruppenangebote_tbl'),
    Node('rg_nichtkjp_gruppenangebote_tbl'),
    Node('rg_jmd_iq_tbl')
])


children = []
tree = Node(TREE_STRUCTURE.name, case_id, children)
for child in TREE_STRUCTURE.children:
    child.recursive_build(case_id, children)
out = []
tree.to_json(out)
return "".join(out)

$$ LANGUAGE plpythonu EXTERNAL SECURITY DEFINER;
ALTER FUNCTION compute_case_structure(int4) OWNER TO :adm_ka_owner;

-- DROP FUNCTION get_case_structure(int4);
CREATE OR REPLACE FUNCTION get_case_structure(case_id int4) RETURNS TEXT AS $$

r = plpy.execute("SELECT modified, cache FROM case_structure "
                 "WHERE master_id = %d" % case_id, 1)

if not r:
    return ""
r = r[0]

if r['modified']: # need refresh
    structure = plpy.execute("SELECT compute_case_structure(%d) as s;"
                             % case_id, 1)[0]["s"]
    plan = plpy.prepare("UPDATE case_structure SET modified = false, "
                        "cache = $1 WHERE master_id = $2", ["text", "int4"])
    plpy.execute(plan, [structure, case_id])
    return structure

return r['cache']

$$ LANGUAGE plpythonu EXTERNAL SECURITY DEFINER;
ALTER FUNCTION get_case_structure(int4) OWNER TO :adm_ka_owner;

-- Continue as db-owner from here
SET ROLE :adm_ka_owner;

--
-- These triggers are used to keep case_structure table in sync.
-- Each time a repeat group is created or deleted the case_structure
-- modified field has to be set to 'true'.
--


-- DROP TRIGGER rg_netzwerk_tbl_insert_trigger ON rg_netzwerk_tbl CASCADE;
-- DROP FUNCTION rg_netzwerk_tbl_insert_func();
-- DROP TRIGGER rg_netzwerk_tbl_delete_trigger ON rg_netzwerk_tbl CASCADE;
-- DROP FUNCTION rg_netzwerk_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_netzwerk_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_netzwerk_tbl_insert_trigger AFTER INSERT ON rg_netzwerk_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_netzwerk_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_netzwerk_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql EXTERNAL SECURITY DEFINER;

CREATE TRIGGER rg_netzwerk_tbl_update_trigger AFTER UPDATE ON rg_netzwerk_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_netzwerk_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_netzwerk_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_netzwerk_tbl_delete_trigger AFTER DELETE ON rg_netzwerk_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_netzwerk_tbl_delete_func();

-- DROP TRIGGER rg_koop_1_tbl_insert_trigger ON rg_koop_1_tbl CASCADE;
-- DROP FUNCTION rg_koop_1_tbl_insert_func();
-- DROP TRIGGER rg_koop_1_tbl_delete_trigger ON rg_koop_1_tbl CASCADE;
-- DROP FUNCTION rg_koop_1_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_koop_1_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_koop_1_tbl_insert_trigger AFTER INSERT ON rg_koop_1_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_1_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_koop_1_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql EXTERNAL SECURITY DEFINER;

CREATE TRIGGER rg_koop_1_tbl_update_trigger AFTER UPDATE ON rg_koop_1_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_1_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_koop_1_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_koop_1_tbl_delete_trigger AFTER DELETE ON rg_koop_1_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_1_tbl_delete_func();

-- DROP TRIGGER rg_koop_2_tbl_insert_trigger ON rg_koop_2_tbl CASCADE;
-- DROP FUNCTION rg_koop_2_tbl_insert_func();
-- DROP TRIGGER rg_koop_2_tbl_delete_trigger ON rg_koop_2_tbl CASCADE;
-- DROP FUNCTION rg_koop_2_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_koop_2_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_koop_2_tbl_insert_trigger AFTER INSERT ON rg_koop_2_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_2_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_koop_2_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql EXTERNAL SECURITY DEFINER;

CREATE TRIGGER rg_koop_2_tbl_update_trigger AFTER UPDATE ON rg_koop_2_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_2_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_koop_2_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_koop_2_tbl_delete_trigger AFTER DELETE ON rg_koop_2_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_2_tbl_delete_func();

-- DROP TRIGGER rg_koop_3_tbl_insert_trigger ON rg_koop_3_tbl CASCADE;
-- DROP FUNCTION rg_koop_3_tbl_insert_func();
-- DROP TRIGGER rg_koop_3_tbl_delete_trigger ON rg_koop_3_tbl CASCADE;
-- DROP FUNCTION rg_koop_3_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_koop_3_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_koop_3_tbl_insert_trigger AFTER INSERT ON rg_koop_3_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_3_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_koop_3_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql EXTERNAL SECURITY DEFINER;

CREATE TRIGGER rg_koop_3_tbl_update_trigger AFTER UPDATE ON rg_koop_3_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_3_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_koop_3_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_koop_3_tbl_delete_trigger AFTER DELETE ON rg_koop_3_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_3_tbl_delete_func();

-- DROP TRIGGER rg_koop_4_tbl_insert_trigger ON rg_koop_4_tbl CASCADE;
-- DROP FUNCTION rg_koop_4_tbl_insert_func();
-- DROP TRIGGER rg_koop_4_tbl_delete_trigger ON rg_koop_4_tbl CASCADE;
-- DROP FUNCTION rg_koop_4_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_koop_4_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_koop_4_tbl_insert_trigger AFTER INSERT ON rg_koop_4_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_4_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_koop_4_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql EXTERNAL SECURITY DEFINER;

CREATE TRIGGER rg_koop_4_tbl_update_trigger AFTER UPDATE ON rg_koop_4_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_4_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_koop_4_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_koop_4_tbl_delete_trigger AFTER DELETE ON rg_koop_4_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_4_tbl_delete_func();

-- DROP TRIGGER rg_koop_5_tbl_insert_trigger ON rg_koop_5_tbl CASCADE;
-- DROP FUNCTION rg_koop_5_tbl_insert_func();
-- DROP TRIGGER rg_koop_5_tbl_delete_trigger ON rg_koop_5_tbl CASCADE;
-- DROP FUNCTION rg_koop_5_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_koop_5_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_koop_5_tbl_insert_trigger AFTER INSERT ON rg_koop_5_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_5_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_koop_5_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql EXTERNAL SECURITY DEFINER;

CREATE TRIGGER rg_koop_5_tbl_update_trigger AFTER UPDATE ON rg_koop_5_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_5_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_koop_5_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_koop_5_tbl_delete_trigger AFTER DELETE ON rg_koop_5_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_5_tbl_delete_func();

-- DROP TRIGGER rg_koop_bewertungen_tbl_insert_trigger ON rg_koop_bewertungen_tbl CASCADE;
-- DROP FUNCTION rg_koop_bewertungen_tbl_insert_func();
-- DROP TRIGGER rg_koop_bewertungen_tbl_delete_trigger ON rg_koop_bewertungen_tbl CASCADE;
-- DROP FUNCTION rg_koop_bewertungen_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_koop_bewertungen_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_koop_bewertungen_tbl_insert_trigger AFTER INSERT ON rg_koop_bewertungen_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_bewertungen_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_koop_bewertungen_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql EXTERNAL SECURITY DEFINER;

CREATE TRIGGER rg_koop_bewertungen_tbl_update_trigger AFTER UPDATE ON rg_koop_bewertungen_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_bewertungen_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_koop_bewertungen_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_koop_bewertungen_tbl_delete_trigger AFTER DELETE ON rg_koop_bewertungen_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_koop_bewertungen_tbl_delete_func();

-- DROP TRIGGER rg_kjp_gruppenangebote_tbl_insert_trigger ON rg_kjp_gruppenangebote_tbl CASCADE;
-- DROP FUNCTION rg_kjp_gruppenangebote_tbl_insert_func();
-- DROP TRIGGER rg_kjp_gruppenangebote_tbl_delete_trigger ON rg_kjp_gruppenangebote_tbl CASCADE;
-- DROP FUNCTION rg_kjp_gruppenangebote_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_kjp_gruppenangebote_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_kjp_gruppenangebote_tbl_insert_trigger AFTER INSERT ON rg_kjp_gruppenangebote_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_kjp_gruppenangebote_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_kjp_gruppenangebote_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql EXTERNAL SECURITY DEFINER;

CREATE TRIGGER rg_kjp_gruppenangebote_tbl_update_trigger AFTER UPDATE ON rg_kjp_gruppenangebote_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_kjp_gruppenangebote_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_kjp_gruppenangebote_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_kjp_gruppenangebote_tbl_delete_trigger AFTER DELETE ON rg_kjp_gruppenangebote_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_kjp_gruppenangebote_tbl_delete_func();

-- DROP TRIGGER rg_nichtkjp_gruppenangebote_tbl_insert_trigger ON rg_nichtkjp_gruppenangebote_tbl CASCADE;
-- DROP FUNCTION rg_nichtkjp_gruppenangebote_tbl_insert_func();
-- DROP TRIGGER rg_nichtkjp_gruppenangebote_tbl_delete_trigger ON rg_nichtkjp_gruppenangebote_tbl CASCADE;
-- DROP FUNCTION rg_nichtkjp_gruppenangebote_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_nichtkjp_gruppenangebote_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_nichtkjp_gruppenangebote_tbl_insert_trigger AFTER INSERT ON rg_nichtkjp_gruppenangebote_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_nichtkjp_gruppenangebote_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_nichtkjp_gruppenangebote_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql EXTERNAL SECURITY DEFINER;

CREATE TRIGGER rg_nichtkjp_gruppenangebote_tbl_update_trigger AFTER UPDATE ON rg_nichtkjp_gruppenangebote_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_nichtkjp_gruppenangebote_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_nichtkjp_gruppenangebote_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_nichtkjp_gruppenangebote_tbl_delete_trigger AFTER DELETE ON rg_nichtkjp_gruppenangebote_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_nichtkjp_gruppenangebote_tbl_delete_func();

-- DROP TRIGGER rg_jmd_iq_tbl_insert_trigger ON rg_jmd_iq_tbl CASCADE;
-- DROP FUNCTION rg_jmd_iq_tbl_insert_func();
-- DROP TRIGGER rg_jmd_iq_tbl_delete_trigger ON rg_jmd_iq_tbl CASCADE;
-- DROP FUNCTION rg_jmd_iq_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_jmd_iq_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_jmd_iq_tbl_insert_trigger AFTER INSERT ON rg_jmd_iq_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_jmd_iq_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_jmd_iq_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql EXTERNAL SECURITY DEFINER;

CREATE TRIGGER rg_jmd_iq_tbl_update_trigger AFTER UPDATE ON rg_jmd_iq_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_jmd_iq_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_jmd_iq_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_jmd_iq_tbl_delete_trigger AFTER DELETE ON rg_jmd_iq_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_jmd_iq_tbl_delete_func();



CREATE OR REPLACE FUNCTION create_master_tbl(nuuid char(36))
    RETURNS integer
    LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    standin integer;
    rid     integer;
BEGIN
    rid := create_master_ds(nuuid);
    IF nuuid IS NULL THEN
        PERFORM create_rg_netzwerk_tbl(rid, NULL);
      PERFORM create_rg_kjp_gruppenangebote_tbl(rid, NULL);
      PERFORM create_rg_nichtkjp_gruppenangebote_tbl(rid, NULL);
    END IF;

    RETURN rid;
END;
$$;

REVOKE ALL ON FUNCTION create_master_tbl(char(36)) FROM PUBLIC;
GRANT EXECUTE ON FUNCTION create_master_tbl(char(36))
    TO GROUP :cm_group;

CREATE OR REPLACE FUNCTION delete_master_tbl(mid integer) RETURNS void
    LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER
    AS $$
DECLARE
    st integer;
BEGIN
    SELECT INTO st s.status FROM master_tbl m JOIN ka_status_tbl s
        ON s.master_id = m.id WHERE m.id = mid;

    IF NOT st in (3, 5) THEN
        RAISE EXCEPTION 'case is not deletable';
    END IF;

    DELETE FROM master_tbl WHERE id = mid;
END;
$$;

REVOKE ALL ON FUNCTION delete_master_tbl(integer) FROM PUBLIC;
GRANT EXECUTE ON FUNCTION delete_master_tbl(integer)
    TO GROUP :admin_group;

CREATE OR REPLACE FUNCTION create_rg_netzwerk_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    INSERT INTO rg_netzwerk_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_netzwerk_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_netzwerk_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_netzwerk_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION delete_rg_netzwerk_tbl(rid integer)
RETURNS void
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid master_id FROM rg_netzwerk_tbl WHERE id = rid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    DELETE FROM rg_netzwerk_tbl WHERE id = rid;
END;
$$;

CREATE OR REPLACE FUNCTION create_rg_koop_1_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    INSERT INTO rg_koop_1_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_koop_1_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_koop_1_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_koop_1_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION delete_rg_koop_1_tbl(rid integer)
RETURNS void
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid master_id FROM rg_koop_1_tbl WHERE id = rid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    DELETE FROM rg_koop_1_tbl WHERE id = rid;
END;
$$;

CREATE OR REPLACE FUNCTION create_rg_koop_2_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    INSERT INTO rg_koop_2_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_koop_2_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_koop_2_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_koop_2_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION delete_rg_koop_2_tbl(rid integer)
RETURNS void
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid master_id FROM rg_koop_2_tbl WHERE id = rid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    DELETE FROM rg_koop_2_tbl WHERE id = rid;
END;
$$;

CREATE OR REPLACE FUNCTION create_rg_koop_3_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    INSERT INTO rg_koop_3_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_koop_3_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_koop_3_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_koop_3_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION delete_rg_koop_3_tbl(rid integer)
RETURNS void
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid master_id FROM rg_koop_3_tbl WHERE id = rid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    DELETE FROM rg_koop_3_tbl WHERE id = rid;
END;
$$;

CREATE OR REPLACE FUNCTION create_rg_koop_4_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    INSERT INTO rg_koop_4_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_koop_4_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_koop_4_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_koop_4_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION delete_rg_koop_4_tbl(rid integer)
RETURNS void
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid master_id FROM rg_koop_4_tbl WHERE id = rid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    DELETE FROM rg_koop_4_tbl WHERE id = rid;
END;
$$;

CREATE OR REPLACE FUNCTION create_rg_koop_5_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    INSERT INTO rg_koop_5_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_koop_5_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_koop_5_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_koop_5_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION delete_rg_koop_5_tbl(rid integer)
RETURNS void
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid master_id FROM rg_koop_5_tbl WHERE id = rid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    DELETE FROM rg_koop_5_tbl WHERE id = rid;
END;
$$;

CREATE OR REPLACE FUNCTION create_rg_koop_bewertungen_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    INSERT INTO rg_koop_bewertungen_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_koop_bewertungen_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_koop_bewertungen_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_koop_bewertungen_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION delete_rg_koop_bewertungen_tbl(rid integer)
RETURNS void
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid master_id FROM rg_koop_bewertungen_tbl WHERE id = rid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    DELETE FROM rg_koop_bewertungen_tbl WHERE id = rid;
END;
$$;

CREATE OR REPLACE FUNCTION create_rg_kjp_gruppenangebote_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    INSERT INTO rg_kjp_gruppenangebote_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_kjp_gruppenangebote_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_kjp_gruppenangebote_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_kjp_gruppenangebote_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION delete_rg_kjp_gruppenangebote_tbl(rid integer)
RETURNS void
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid master_id FROM rg_kjp_gruppenangebote_tbl WHERE id = rid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    DELETE FROM rg_kjp_gruppenangebote_tbl WHERE id = rid;
END;
$$;

CREATE OR REPLACE FUNCTION create_rg_nichtkjp_gruppenangebote_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    INSERT INTO rg_nichtkjp_gruppenangebote_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_nichtkjp_gruppenangebote_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_nichtkjp_gruppenangebote_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_nichtkjp_gruppenangebote_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION delete_rg_nichtkjp_gruppenangebote_tbl(rid integer)
RETURNS void
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid master_id FROM rg_nichtkjp_gruppenangebote_tbl WHERE id = rid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    DELETE FROM rg_nichtkjp_gruppenangebote_tbl WHERE id = rid;
END;
$$;

CREATE OR REPLACE FUNCTION create_rg_jmd_iq_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    INSERT INTO rg_jmd_iq_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_jmd_iq_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_jmd_iq_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_jmd_iq_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION delete_rg_jmd_iq_tbl(rid integer)
RETURNS void
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid master_id FROM rg_jmd_iq_tbl WHERE id = rid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    DELETE FROM rg_jmd_iq_tbl WHERE id = rid;
END;
$$;


COMMIT;

