-- Upgrade script for multiselect changes in struktur part
--
-- mpuls/issue7449

--
-- From install-coaches/01master.sql
--

CREATE TABLE methode_tbl (
    id INTEGER PRIMARY KEY NOT NULL,
    value VARCHAR(83) NOT NULL
);
CREATE TABLE format_tbl (
    id INTEGER PRIMARY KEY NOT NULL,
    value VARCHAR(20) NOT NULL
);
CREATE TABLE inhalte_tbl (
    id INTEGER PRIMARY KEY NOT NULL,
    value VARCHAR(54) NOT NULL
);
CREATE TABLE klassenstufen_tbl (
    id INTEGER PRIMARY KEY NOT NULL,
    value VARCHAR(18) NOT NULL
);


GRANT SELECT ON methode_tbl TO GROUP :cm_group;
GRANT SELECT ON methode_tbl TO GROUP :admin_group;
GRANT SELECT ON format_tbl TO GROUP :cm_group;
GRANT SELECT ON format_tbl TO GROUP :admin_group;
GRANT SELECT ON inhalte_tbl TO GROUP :cm_group;
GRANT SELECT ON inhalte_tbl TO GROUP :admin_group;
GRANT SELECT ON klassenstufen_tbl TO GROUP :cm_group;
GRANT SELECT ON klassenstufen_tbl TO GROUP :admin_group;


INSERT INTO methode_tbl (id, value) VALUES (1, 'Gruppendiskussion');
INSERT INTO methode_tbl (id, value) VALUES (2, 'Erlebnispädagogik (z.B. sportliche Aktivitäten)');
INSERT INTO methode_tbl (id, value) VALUES (3, 'Theaterpädagogik  ');
INSERT INTO methode_tbl (id, value) VALUES (4, 'Musikpädagogik (z.B. Rap)');
INSERT INTO methode_tbl (id, value) VALUES (5, 'Kunstpädagogik (z.B. Graffiti, Foto)');
INSERT INTO methode_tbl (id, value) VALUES (6, 'Medienpädagogik (z.B. Film, Radio, Soziale Medien)');
INSERT INTO methode_tbl (id, value) VALUES (7, 'Anti-Gewalt/ Anti-Konflikt Training');
INSERT INTO methode_tbl (id, value) VALUES (8, 'Multiplikator*innen-Ausbildung / Peer-to-Peer Ansatz (z.B. Streitschlichter*innen)');
INSERT INTO methode_tbl (id, value) VALUES (9, 'Planspiel');
INSERT INTO methode_tbl (id, value) VALUES (10, 'Museumspädagogik/Stadtführung ');
INSERT INTO methode_tbl (id, value) VALUES (11, 'Vortrag');

INSERT INTO format_tbl (id, value) VALUES (-2, 'Sonstiges');
INSERT INTO format_tbl (id, value) VALUES (1, 'AG');
INSERT INTO format_tbl (id, value) VALUES (2, 'Ausflug');
INSERT INTO format_tbl (id, value) VALUES (3, 'Klassenfahrt');
INSERT INTO format_tbl (id, value) VALUES (4, 'Veranstaltung');
INSERT INTO format_tbl (id, value) VALUES (5, 'Veranstaltungsreihe');
INSERT INTO format_tbl (id, value) VALUES (6, 'Workshop');
INSERT INTO format_tbl (id, value) VALUES (7, 'Workshopreihe');

INSERT INTO inhalte_tbl (id, value) VALUES (1, 'Demokratiebildung');
INSERT INTO inhalte_tbl (id, value) VALUES (2, 'Stärkung der interkulturellen Kompetenz');
INSERT INTO inhalte_tbl (id, value) VALUES (3, 'Stärkung der interreligiösen Kompetenz');
INSERT INTO inhalte_tbl (id, value) VALUES (4, 'Geschlechter-Reflektierte Arbeit/ Rollenbilder');
INSERT INTO inhalte_tbl (id, value) VALUES (5, 'Stärkung der Selbstwirksamkeit');
INSERT INTO inhalte_tbl (id, value) VALUES (6, 'Stärkung der Sozialen Kompetenz');
INSERT INTO inhalte_tbl (id, value) VALUES (7, 'Stärkung der Medienkompetenz');
INSERT INTO inhalte_tbl (id, value) VALUES (8, 'Auseinandersetzung mit menschenfeindlichen Ideologien');
INSERT INTO inhalte_tbl (id, value) VALUES (9, 'Mobbing im religiösen Kontext');
INSERT INTO inhalte_tbl (id, value) VALUES (10, 'Auseinandersetzung mit Rechtsextremismus');

INSERT INTO klassenstufen_tbl (id, value) VALUES (5, '5');
INSERT INTO klassenstufen_tbl (id, value) VALUES (6, '6');
INSERT INTO klassenstufen_tbl (id, value) VALUES (7, '7');
INSERT INTO klassenstufen_tbl (id, value) VALUES (8, '8');
INSERT INTO klassenstufen_tbl (id, value) VALUES (9, '9');
INSERT INTO klassenstufen_tbl (id, value) VALUES (10, '10');
INSERT INTO klassenstufen_tbl (id, value) VALUES (11, '11');
INSERT INTO klassenstufen_tbl (id, value) VALUES (12, '12');
INSERT INTO klassenstufen_tbl (id, value) VALUES (13, '13');
INSERT INTO klassenstufen_tbl (id, value) VALUES (100, 'Berufliche Schule');



CREATE TABLE nm_klassenstufen_tbl (
    rg_gruppenangebote_id INTEGER NOT NULL,
    choice_id int4 NOT NULL,
    FOREIGN KEY (rg_gruppenangebote_id) REFERENCES rg_gruppenangebote_tbl (id) ON DELETE CASCADE,
    FOREIGN KEY (choice_id) REFERENCES klassenstufen_tbl (id),
    PRIMARY KEY (rg_gruppenangebote_id, choice_id)
);
CREATE TABLE nm_inhalte_tbl (
    rg_gruppenangebote_id INTEGER NOT NULL,
    choice_id int4 NOT NULL,
    FOREIGN KEY (rg_gruppenangebote_id) REFERENCES rg_gruppenangebote_tbl (id) ON DELETE CASCADE,
    FOREIGN KEY (choice_id) REFERENCES inhalte_tbl (id),
    PRIMARY KEY (rg_gruppenangebote_id, choice_id)
);
CREATE TABLE nm_format_tbl (
    rg_gruppenangebote_id INTEGER NOT NULL,
    choice_id int4 NOT NULL,
    FOREIGN KEY (rg_gruppenangebote_id) REFERENCES rg_gruppenangebote_tbl (id) ON DELETE CASCADE,
    FOREIGN KEY (choice_id) REFERENCES format_tbl (id),
    PRIMARY KEY (rg_gruppenangebote_id, choice_id)
);
CREATE TABLE nm_methode_tbl (
    rg_gruppenangebote_id INTEGER NOT NULL,
    choice_id int4 NOT NULL,
    FOREIGN KEY (rg_gruppenangebote_id) REFERENCES rg_gruppenangebote_tbl (id) ON DELETE CASCADE,
    FOREIGN KEY (choice_id) REFERENCES methode_tbl (id),
    PRIMARY KEY (rg_gruppenangebote_id, choice_id)
);


INSERT INTO nm_methode_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 1 FROM rg_gruppenangebote_tbl
      WHERE methode_gruppendiskussion = 1;
INSERT INTO nm_methode_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 2 FROM rg_gruppenangebote_tbl
      WHERE methode_erlebnispaedagogik = 1;
INSERT INTO nm_methode_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 3 FROM rg_gruppenangebote_tbl
      WHERE methode_theaterpaedagogik = 1;
INSERT INTO nm_methode_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 4 FROM rg_gruppenangebote_tbl
      WHERE methode_musikpaedagogik = 1;
INSERT INTO nm_methode_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 5 FROM rg_gruppenangebote_tbl
      WHERE methode_kunstpaedagogik = 1;
INSERT INTO nm_methode_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 6 FROM rg_gruppenangebote_tbl
      WHERE methode_medienpaedagogik = 1;
INSERT INTO nm_methode_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 7 FROM rg_gruppenangebote_tbl
      WHERE methode_anti_gewalt_training = 1;
INSERT INTO nm_methode_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 8 FROM rg_gruppenangebote_tbl
      WHERE methode_multiplikator_ausbildung = 1;
INSERT INTO nm_methode_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 9 FROM rg_gruppenangebote_tbl
      WHERE methode_planspiel = 1;
INSERT INTO nm_methode_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 10 FROM rg_gruppenangebote_tbl
      WHERE methode_museumspaedagogik = 1;
INSERT INTO nm_methode_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 11 FROM rg_gruppenangebote_tbl
      WHERE methode_vortrag = 1;


INSERT INTO nm_format_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, -2 FROM rg_gruppenangebote_tbl
      WHERE format_sonstiges = 1;
INSERT INTO nm_format_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 1 FROM rg_gruppenangebote_tbl
      WHERE format_ag = 1;
INSERT INTO nm_format_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 2 FROM rg_gruppenangebote_tbl
      WHERE format_ausflug = 1;
INSERT INTO nm_format_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 3 FROM rg_gruppenangebote_tbl
      WHERE format_klassenfahrt = 1;
INSERT INTO nm_format_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 4 FROM rg_gruppenangebote_tbl
      WHERE format_veranstaltung = 1;
INSERT INTO nm_format_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 5 FROM rg_gruppenangebote_tbl
      WHERE format_veranstaltungsreihe = 1;
INSERT INTO nm_format_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 6 FROM rg_gruppenangebote_tbl
      WHERE format_workshop = 1;
INSERT INTO nm_format_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 7 FROM rg_gruppenangebote_tbl
      WHERE format_workshopreihe = 1;


INSERT INTO nm_inhalte_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 1 FROM rg_gruppenangebote_tbl
      WHERE inhalt_demokratiebildung = 1;
INSERT INTO nm_inhalte_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 2 FROM rg_gruppenangebote_tbl
      WHERE inhalt_interkulturelle_kompetenz = 1;
INSERT INTO nm_inhalte_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 3 FROM rg_gruppenangebote_tbl
      WHERE inhalt_interreligioese_kompetenz = 1;
INSERT INTO nm_inhalte_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 4 FROM rg_gruppenangebote_tbl
      WHERE inhalt_geschlechter_reflektierte_arbeit = 1;
INSERT INTO nm_inhalte_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 5 FROM rg_gruppenangebote_tbl
      WHERE inhalt_staerkung_der_selbstwirksamkeit = 1;
INSERT INTO nm_inhalte_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 6 FROM rg_gruppenangebote_tbl
      WHERE inhalt_soziale_kompetenz = 1;
INSERT INTO nm_inhalte_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 7 FROM rg_gruppenangebote_tbl
      WHERE inhalt_medienkompetenz = 1;
INSERT INTO nm_inhalte_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 8 FROM rg_gruppenangebote_tbl
      WHERE inhalt_auseinandersetzung_menschfeindliche_ideologien = 1;
INSERT INTO nm_inhalte_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 9 FROM rg_gruppenangebote_tbl
      WHERE inhalt_religioeses_mobbing = 1;
INSERT INTO nm_inhalte_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 10 FROM rg_gruppenangebote_tbl
      WHERE inhalt_primaerpraevention_rechtsextremismus = 1;



INSERT INTO nm_klassenstufen_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 5 FROM rg_gruppenangebote_tbl
      WHERE klassenstufe_5 = 1;
INSERT INTO nm_klassenstufen_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 6 FROM rg_gruppenangebote_tbl
      WHERE klassenstufe_6 = 1;
INSERT INTO nm_klassenstufen_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 7 FROM rg_gruppenangebote_tbl
      WHERE klassenstufe_7 = 1;
INSERT INTO nm_klassenstufen_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 8 FROM rg_gruppenangebote_tbl
      WHERE klassenstufe_8 = 1;
INSERT INTO nm_klassenstufen_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 9 FROM rg_gruppenangebote_tbl
      WHERE klassenstufe_9 = 1;
INSERT INTO nm_klassenstufen_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 10 FROM rg_gruppenangebote_tbl
      WHERE klassenstufe_10 = 1;
INSERT INTO nm_klassenstufen_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 11 FROM rg_gruppenangebote_tbl
      WHERE klassenstufe_11 = 1;
INSERT INTO nm_klassenstufen_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 12 FROM rg_gruppenangebote_tbl
      WHERE klassenstufe_12 = 1;
INSERT INTO nm_klassenstufen_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 13 FROM rg_gruppenangebote_tbl
      WHERE klassenstufe_13 = 1;
INSERT INTO nm_klassenstufen_tbl(rg_gruppenangebote_id, choice_id)
     SELECT id, 100 FROM rg_gruppenangebote_tbl
      WHERE klassenstufe_berufliche_schule = 1;


ALTER TABLE rg_gruppenangebote_tbl
 DROP COLUMN klassenstufe_5,
 DROP COLUMN klassenstufe_6,
 DROP COLUMN klassenstufe_7,
 DROP COLUMN klassenstufe_8,
 DROP COLUMN klassenstufe_9,
 DROP COLUMN klassenstufe_10,
 DROP COLUMN klassenstufe_11,
 DROP COLUMN klassenstufe_12,
 DROP COLUMN klassenstufe_13,
 DROP COLUMN klassenstufe_berufliche_schule,
 DROP COLUMN inhalt_demokratiebildung,
 DROP COLUMN inhalt_interkulturelle_kompetenz,
 DROP COLUMN inhalt_interreligioese_kompetenz,
 DROP COLUMN inhalt_geschlechter_reflektierte_arbeit,
 DROP COLUMN inhalt_staerkung_der_selbstwirksamkeit,
 DROP COLUMN inhalt_soziale_kompetenz,
 DROP COLUMN inhalt_medienkompetenz,
 DROP COLUMN inhalt_auseinandersetzung_menschfeindliche_ideologien,
 DROP COLUMN inhalt_religioeses_mobbing,
 DROP COLUMN inhalt_primaerpraevention_rechtsextremismus,
 DROP COLUMN format_ag,
 DROP COLUMN format_ausflug,
 DROP COLUMN format_klassenfahrt,
 DROP COLUMN format_veranstaltung,
 DROP COLUMN format_veranstaltungsreihe,
 DROP COLUMN format_workshop,
 DROP COLUMN format_workshopreihe,
 DROP COLUMN format_sonstiges,
 DROP COLUMN methode_gruppendiskussion,
 DROP COLUMN methode_erlebnispaedagogik,
 DROP COLUMN methode_theaterpaedagogik,
 DROP COLUMN methode_musikpaedagogik,
 DROP COLUMN methode_kunstpaedagogik,
 DROP COLUMN methode_medienpaedagogik,
 DROP COLUMN methode_anti_gewalt_training,
 DROP COLUMN methode_multiplikator_ausbildung,
 DROP COLUMN methode_planspiel,
 DROP COLUMN methode_museumspaedagogik,
 DROP COLUMN methode_vortrag;
