BEGIN;
-- issue1996: Auswertung Strukturteil
SET ROLE :db_adm;

INSERT INTO db_history (beschreibung, zeitpunkt)
VALUES ('1.1/01_master_tbl_view.sql', current_timestamp);


-- ----------------------------------------------------------
-- Recreate all the VIEWs for the evaluation, so the structure user can see the
-- cases (don't check for ownership)
-- ----------------------------------------------------------


--
-- master_tbl_eval_total_view
--
DROP VIEW master_tbl_eval_total_view CASCADE;
-- loescht ebenfalls Regel _RETURN fuer Sicht master_tbl_eval_incm_view
-- loescht ebenfalls Sicht master_tbl_eval_incm_view

CREATE OR REPLACE  VIEW master_tbl_eval_total_view AS
SELECT m.* FROM master_tbl m JOIN ka_status_tbl s
    ON m.id = s.master_id
    WHERE
        s.status <> 3
        OR pg_has_role('admin','MEMBER');
GRANT SELECT ON master_tbl_eval_total_view TO GROUP :cm_group;
GRANT SELECT ON master_tbl_eval_total_view TO GROUP :admin_group;

CREATE OR REPLACE  VIEW master_tbl_eval_incm_view AS
SELECT * FROM master_tbl_eval_total_view
    WHERE phase IN (1);

GRANT SELECT ON public.master_tbl_eval_incm_view TO :cm_group;
GRANT SELECT ON public.master_tbl_eval_incm_view TO :admin_group;




--
-- rg_kjp_gruppenangebote_tbl_view
--
DROP VIEW rg_kjp_gruppenangebote_tbl_view CASCADE;
-- loescht ebenfalls Regel _RETURN fuer Sicht rg_kjp_gruppenangebote_tbl_anonym_view
-- loescht ebenfalls Sicht rg_kjp_gruppenangebote_tbl_anonym_view
-- loescht ebenfalls Regel rg_kjp_gruppenangebote_tbl_anonym_insert_rule fuer Sicht rg_kjp_gruppenangebote_tbl_anonym_view
-- loescht ebenfalls Regel rg_kjp_gruppenangebote_tbl_anonym_delete_rule fuer Sicht rg_kjp_gruppenangebote_tbl_anonym_view

CREATE OR REPLACE VIEW rg_kjp_gruppenangebote_tbl_view
AS SELECT 
     rg_kjp_gruppenangebote_tbl.*
FROM rg_kjp_gruppenangebote_tbl
    INNER JOIN master_tbl
    ON         rg_kjp_gruppenangebote_tbl.master_id = master_tbl.id;

CREATE OR REPLACE RULE rg_kjp_gruppenangebote_tbl_update_rule AS ON UPDATE TO rg_kjp_gruppenangebote_tbl_view
DO INSTEAD UPDATE rg_kjp_gruppenangebote_tbl SET
    kjp_grp_art_angebot = NEW.kjp_grp_art_angebot,
    kjp_grp_anzahl_teilnehmer_maennlich = NEW.kjp_grp_anzahl_teilnehmer_maennlich,
    kjp_grp_anzahl_teilnehmer_weiblich = NEW.kjp_grp_anzahl_teilnehmer_weiblich,
    kjp_grp_alter = NEW.kjp_grp_alter,
    kjp_grp_alter2 = NEW.kjp_grp_alter2,
    kjp_grp_alter3 = NEW.kjp_grp_alter3,
    kjp_grp_weitere_angaben = NEW.kjp_grp_weitere_angaben
WHERE id = NEW.id;


GRANT SELECT ON rg_kjp_gruppenangebote_tbl_view TO GROUP :cm_group;
GRANT SELECT ON rg_kjp_gruppenangebote_tbl_view TO GROUP :admin_group;


CREATE OR REPLACE VIEW rg_kjp_gruppenangebote_tbl_anonym_view
AS SELECT
    * FROM rg_kjp_gruppenangebote_tbl_view;

CREATE OR REPLACE RULE rg_kjp_gruppenangebote_tbl_anonym_delete_rule AS ON DELETE TO rg_kjp_gruppenangebote_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_kjp_gruppenangebote_tbl_anonym_insert_rule AS ON INSERT TO rg_kjp_gruppenangebote_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_kjp_gruppenangebote_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON rg_kjp_gruppenangebote_tbl_anonym_view TO GROUP :admin_group;




--
-- rg_nichtkjp_gruppenangebote_tbl_view
--
DROP VIEW rg_nichtkjp_gruppenangebote_tbl_view CASCADE;
-- loescht ebenfalls Regel _RETURN fuer Sicht rg_nichtkjp_gruppenangebote_tbl_anonym_view
-- loescht ebenfalls Sicht rg_nichtkjp_gruppenangebote_tbl_anonym_view
-- loescht ebenfalls Regel rg_nichtkjp_gruppenangebote_tbl_anonym_insert_rule fuer Sicht rg_nichtkjp_gruppenangebote_tbl_anonym_view
-- loescht ebenfalls Regel rg_nichtkjp_gruppenangebote_tbl_anonym_delete_rule fuer Sicht rg_nichtkjp_gruppenangebote_tbl_anonym_view
CREATE OR REPLACE VIEW rg_nichtkjp_gruppenangebote_tbl_view
AS SELECT
     rg_nichtkjp_gruppenangebote_tbl.*
FROM rg_nichtkjp_gruppenangebote_tbl
    INNER JOIN master_tbl
    ON         rg_nichtkjp_gruppenangebote_tbl.master_id = master_tbl.id;

CREATE OR REPLACE RULE rg_nichtkjp_gruppenangebote_tbl_update_rule AS ON UPDATE TO rg_nichtkjp_gruppenangebote_tbl_view
DO INSTEAD UPDATE rg_nichtkjp_gruppenangebote_tbl SET
    nichtkjp_grp_art_angebot = NEW.nichtkjp_grp_art_angebot,
    nichtkjp_grp_anzahl_teilnehmer_maennlich = NEW.nichtkjp_grp_anzahl_teilnehmer_maennlich,
    nichtkjp_grp_anzahl_teilnehmer_weiblich = NEW.nichtkjp_grp_anzahl_teilnehmer_weiblich,
    nichtkjp_grp_alter = NEW.nichtkjp_grp_alter,
    nichtkjp_grp_alter2 = NEW.nichtkjp_grp_alter2,
    nichtkjp_grp_alter3 = NEW.nichtkjp_grp_alter3,
    nichtkjp_grp_weitere_angaben = NEW.nichtkjp_grp_weitere_angaben
WHERE id = NEW.id;


GRANT SELECT ON rg_nichtkjp_gruppenangebote_tbl_view TO GROUP :cm_group;
GRANT SELECT ON rg_nichtkjp_gruppenangebote_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW rg_nichtkjp_gruppenangebote_tbl_anonym_view
AS SELECT
    * FROM rg_nichtkjp_gruppenangebote_tbl_view;

CREATE OR REPLACE RULE rg_nichtkjp_gruppenangebote_tbl_anonym_delete_rule AS ON DELETE TO rg_nichtkjp_gruppenangebote_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_nichtkjp_gruppenangebote_tbl_anonym_insert_rule AS ON INSERT TO rg_nichtkjp_gruppenangebote_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_nichtkjp_gruppenangebote_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON rg_nichtkjp_gruppenangebote_tbl_anonym_view TO GROUP :admin_group;




--
-- rg_kooperationsbezug_tbl_view
--
DROP VIEW rg_kooperationsbezug_tbl_view CASCADE;
-- loescht ebenfalls Regel _RETURN fuer Sicht rg_kooperationsbezug_tbl_anonym_view
-- loescht ebenfalls Sicht rg_kooperationsbezug_tbl_anonym_view
-- loescht ebenfalls Regel rg_kooperationsbezug_tbl_anonym_insert_rule fuer Sicht rg_kooperationsbezug_tbl_anonym_view
-- loescht ebenfalls Regel rg_kooperationsbezug_tbl_anonym_delete_rule fuer Sicht rg_kooperationsbezug_tbl_anonym_view
CREATE OR REPLACE VIEW rg_kooperationsbezug_tbl_view
AS SELECT 
     rg_kooperationsbezug_tbl.*
FROM rg_kooperationsbezug_tbl
    INNER JOIN master_tbl
    ON         rg_kooperationsbezug_tbl.master_id = master_tbl.id;

CREATE OR REPLACE RULE rg_kooperationsbezug_tbl_update_rule AS ON UPDATE TO rg_kooperationsbezug_tbl_view
DO INSTEAD UPDATE rg_kooperationsbezug_tbl SET
    institution_art = NEW.institution_art,
    institution_ist = NEW.institution_ist,
    institution_angaben = NEW.institution_angaben,
    kooperationspartner_nennung = NEW.kooperationspartner_nennung,
    institution_unterstuetzt_aktiv = NEW.institution_unterstuetzt_aktiv,
    jmd_erreicht_andere_durchfuehrung = NEW.jmd_erreicht_andere_durchfuehrung,
    jmd_hat_einfluss_teilnehmer = NEW.jmd_hat_einfluss_teilnehmer,
    institution_legt_infomaterial = NEW.institution_legt_infomaterial,
    institution_zufuehrung_menschen = NEW.institution_zufuehrung_menschen,
    besteht_informationsaustausch = NEW.besteht_informationsaustausch,
    besteht_regelmaessiger_austausch_fallbezogen = NEW.besteht_regelmaessiger_austausch_fallbezogen,
    besteht_regelmaessiger_austausch_nichtfallbezogen = NEW.besteht_regelmaessiger_austausch_nichtfallbezogen,
    besteht_abstimmung_integrationsfp = NEW.besteht_abstimmung_integrationsfp,
    besteht_planung_veranstaltung = NEW.besteht_planung_veranstaltung,
    besteht_gemeinsame_oeffentlichkeitsarbeit = NEW.besteht_gemeinsame_oeffentlichkeitsarbeit,
    kontakt_besteht_ueber_gremien = NEW.kontakt_besteht_ueber_gremien,
    jmd_nimmt_an_verstaltungen_teil = NEW.jmd_nimmt_an_verstaltungen_teil,
    jmd_fuehrt_beratung_durch = NEW.jmd_fuehrt_beratung_durch,
    kooperation_schriftlich_festgelegt = NEW.kooperation_schriftlich_festgelegt,
    jmd_als_partner_auf_augenhoehe = NEW.jmd_als_partner_auf_augenhoehe,
    kontaktform = NEW.kontaktform,
    gesamtbewertung = NEW.gesamtbewertung,
    nennung_besonderheiten_zusammenarbeit = NEW.nennung_besonderheiten_zusammenarbeit,
    nennung_erfahrungen_zusammenarbeit = NEW.nennung_erfahrungen_zusammenarbeit
WHERE id = NEW.id;

GRANT SELECT ON rg_kooperationsbezug_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON rg_kooperationsbezug_tbl_view TO GROUP :cm_group;
GRANT SELECT ON rg_kooperationsbezug_tbl_view TO GROUP :admin_group;


CREATE OR REPLACE VIEW rg_kooperationsbezug_tbl_anonym_view
AS SELECT
    * FROM rg_kooperationsbezug_tbl_view;

CREATE OR REPLACE RULE rg_kooperationsbezug_tbl_anonym_delete_rule AS ON DELETE TO rg_kooperationsbezug_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_kooperationsbezug_tbl_anonym_insert_rule AS ON INSERT TO rg_kooperationsbezug_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_kooperationsbezug_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON rg_kooperationsbezug_tbl_anonym_view TO GROUP :admin_group;


--
-- rg_netzwerk_tbl_view
--
DROP VIEW rg_netzwerk_tbl_view CASCADE;
-- loescht ebenfalls Regel _RETURN fuer Sicht rg_netzwerk_tbl_anonym_view
-- loescht ebenfalls Sicht rg_netzwerk_tbl_anonym_view
-- loescht ebenfalls Regel rg_netzwerk_tbl_anonym_insert_rule fuer Sicht rg_netzwerk_tbl_anonym_view
-- loescht ebenfalls Regel rg_netzwerk_tbl_anonym_delete_rule fuer Sicht rg_netzwerk_tbl_anonym_view
CREATE OR REPLACE VIEW rg_netzwerk_tbl_view
AS SELECT 
     rg_netzwerk_tbl.*
FROM rg_netzwerk_tbl
    INNER JOIN master_tbl
    ON         rg_netzwerk_tbl.master_id = master_tbl.id;

CREATE OR REPLACE RULE rg_netzwerk_tbl_update_rule AS ON UPDATE TO rg_netzwerk_tbl_view
DO INSTEAD UPDATE rg_netzwerk_tbl SET
    zielgruppen_netzwerk = NEW.zielgruppen_netzwerk,
    zielgruppen_netzwerk_nennung = NEW.zielgruppen_netzwerk_nennung,
    mitarbeit_netzwerk = NEW.mitarbeit_netzwerk,
    mitarbeit_netzwerk_erlaueterung = NEW.mitarbeit_netzwerk_erlaueterung,
    beteiligung_integrationskonzepte = NEW.beteiligung_integrationskonzepte,
    beteiligung_integrationskonzepte_erlaeuterung = NEW.beteiligung_integrationskonzepte_erlaeuterung
WHERE id = NEW.id;


GRANT SELECT ON rg_netzwerk_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON rg_netzwerk_tbl_view TO GROUP :cm_group;
GRANT SELECT ON rg_netzwerk_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW rg_netzwerk_tbl_anonym_view
AS SELECT
    * FROM rg_netzwerk_tbl_view;

CREATE OR REPLACE RULE rg_netzwerk_tbl_anonym_delete_rule AS ON DELETE TO rg_netzwerk_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_netzwerk_tbl_anonym_insert_rule AS ON INSERT TO rg_netzwerk_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_netzwerk_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON rg_netzwerk_tbl_anonym_view TO GROUP :admin_group;

--
-- Finish
--
SET ROLE postgres;
COMMIT;
