BEGIN;
-- issue2127: Übersicht Darstellung der Netzwerke
-- issue2171: Erweiterung des Feldes "Nennung Koordinierungsstelle"
SET ROLE :db_adm;

INSERT INTO db_history (beschreibung, zeitpunkt)
VALUES ('1.1/02_uebersicht_netzwerke.sql', current_timestamp);


-- ----------------------------------------------------------
-- Change the type of column to text, make VARCHAR longer
-- ----------------------------------------------------------

DROP VIEW rg_netzwerk_tbl_view CASCADE;
-- loescht ebenfalls Regel _RETURN fuer Sicht rg_netzwerk_tbl_anonym_view
-- loescht ebenfalls Sicht rg_netzwerk_tbl_anonym_view
-- loescht ebenfalls Regel rg_netzwerk_tbl_anonym_insert_rule fuer Sicht rg_netzwerk_tbl_anonym_view
-- loescht ebenfalls Regel rg_netzwerk_tbl_anonym_delete_rule fuer Sicht rg_netzwerk_tbl_anonym_view

ALTER TABLE rg_netzwerk_tbl ALTER COLUMN beteiligung_integrationskonzepte_erlaeuterung TYPE TEXT;
ALTER TABLE rg_netzwerk_tbl ALTER COLUMN zielgruppen_netzwerk_nennung TYPE VARCHAR(180);

CREATE OR REPLACE VIEW rg_netzwerk_tbl_view
AS SELECT 
     rg_netzwerk_tbl.*
FROM rg_netzwerk_tbl
    INNER JOIN master_tbl
    ON         rg_netzwerk_tbl.master_id = master_tbl.id;

CREATE OR REPLACE RULE rg_netzwerk_tbl_update_rule AS ON UPDATE TO rg_netzwerk_tbl_view
DO INSTEAD UPDATE rg_netzwerk_tbl SET
    zielgruppen_netzwerk = NEW.zielgruppen_netzwerk,
    zielgruppen_netzwerk_nennung = NEW.zielgruppen_netzwerk_nennung,
    mitarbeit_netzwerk = NEW.mitarbeit_netzwerk,
    mitarbeit_netzwerk_erlaueterung = NEW.mitarbeit_netzwerk_erlaueterung,
    beteiligung_integrationskonzepte = NEW.beteiligung_integrationskonzepte,
    beteiligung_integrationskonzepte_erlaeuterung = NEW.beteiligung_integrationskonzepte_erlaeuterung
WHERE id = NEW.id;


GRANT SELECT ON rg_netzwerk_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON rg_netzwerk_tbl_view TO GROUP :cm_group;
GRANT SELECT ON rg_netzwerk_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW rg_netzwerk_tbl_anonym_view
AS SELECT
    * FROM rg_netzwerk_tbl_view;

CREATE OR REPLACE RULE rg_netzwerk_tbl_anonym_delete_rule AS ON DELETE TO rg_netzwerk_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_netzwerk_tbl_anonym_insert_rule AS ON INSERT TO rg_netzwerk_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_netzwerk_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON rg_netzwerk_tbl_anonym_view TO GROUP :admin_group;

--
-- Finish
--
SET ROLE postgres;
COMMIT;
