-- Upgrade script for multiselect changes in struktur part
--
-- mpuls/issue7449

--
-- From install-struktur/01master.sql
--

CREATE TABLE weiter_akt_art_tbl (
    id INTEGER PRIMARY KEY NOT NULL,
    value VARCHAR(39) NOT NULL
);

GRANT SELECT ON weiter_akt_art_tbl TO GROUP :cm_group;
GRANT SELECT ON weiter_akt_art_tbl TO GROUP :admin_group;


INSERT INTO weiter_akt_art_tbl (id, value) VALUES (-2, 'Sonstiges');
INSERT INTO weiter_akt_art_tbl (id, value) VALUES (1, 'interkulturelle Öffnung');
INSERT INTO weiter_akt_art_tbl (id, value) VALUES (2, 'aufsuchende Arbeit');
INSERT INTO weiter_akt_art_tbl (id, value) VALUES (3, 'Elternberatung');
INSERT INTO weiter_akt_art_tbl (id, value) VALUES (4, 'Förderung des freiwilligen Engagements');
INSERT INTO weiter_akt_art_tbl (id, value) VALUES (5, 'keine weitere Aktivität');


CREATE TABLE nm_weiter_akt_art_tbl (
    master_id INTEGER NOT NULL,
    choice_id int4 NOT NULL,
    FOREIGN KEY (master_id) REFERENCES master_tbl (id) ON DELETE CASCADE,
    FOREIGN KEY (choice_id) REFERENCES weiter_akt_art_tbl (id),
    PRIMARY KEY (master_id, choice_id)
);


INSERT INTO nm_weiter_akt_art_tbl(master_id, choice_id)
     SELECT id, -2 FROM master_tbl
      WHERE weiter_akt_art_sonstiges = 1;
INSERT INTO nm_weiter_akt_art_tbl(master_id, choice_id)
     SELECT id, 1 FROM master_tbl
      WHERE weiter_akt_art_interkulturell = 1;
INSERT INTO nm_weiter_akt_art_tbl(master_id, choice_id)
     SELECT id, 2 FROM master_tbl
      WHERE weiter_akt_art_aufsuchende = 1;
INSERT INTO nm_weiter_akt_art_tbl(master_id, choice_id)
     SELECT id, 3 FROM master_tbl
      WHERE weiter_akt_art_eltern = 1;
INSERT INTO nm_weiter_akt_art_tbl(master_id, choice_id)
     SELECT id, 4 FROM master_tbl
      WHERE weiter_akt_art_freiwilligerdienst = 1;
INSERT INTO nm_weiter_akt_art_tbl(master_id, choice_id)
     SELECT id, 5 FROM master_tbl
      WHERE weiter_akt_art_keine = 1;



ALTER TABLE master_tbl
 DROP COLUMN weiter_akt_art_interkulturell,
 DROP COLUMN weiter_akt_art_aufsuchende,
 DROP COLUMN weiter_akt_art_eltern,
 DROP COLUMN weiter_akt_art_freiwilligerdienst,
 DROP COLUMN weiter_akt_art_sonstiges,
 DROP COLUMN weiter_akt_art_keine;
 





CREATE TABLE kjp_alter_tbl (
    id INTEGER PRIMARY KEY NOT NULL,
    value VARCHAR(17) NOT NULL
);

GRANT SELECT ON kjp_alter_tbl TO GROUP :cm_group;
GRANT SELECT ON kjp_alter_tbl TO GROUP :admin_group;

INSERT INTO kjp_alter_tbl (id, value) VALUES (1, '12 bis 14 Jahre ');
INSERT INTO kjp_alter_tbl (id, value) VALUES (2, '15 bis 18 Jahre ');
INSERT INTO kjp_alter_tbl (id, value) VALUES (3, '19 bis 27 Jahre ');


CREATE TABLE nm_kjp_alter_tbl (
    rg_kjp_gruppenangebote_id INTEGER NOT NULL,
    choice_id int4 NOT NULL,
    FOREIGN KEY (rg_kjp_gruppenangebote_id) REFERENCES rg_kjp_gruppenangebote_tbl (id) ON DELETE CASCADE,
    FOREIGN KEY (choice_id) REFERENCES kjp_alter_tbl (id),
    PRIMARY KEY (rg_kjp_gruppenangebote_id, choice_id)
);


INSERT INTO nm_kjp_alter_tbl(rg_kjp_gruppenangebote_id, choice_id)
     SELECT id, 1 FROM rg_kjp_gruppenangebote_tbl
      WHERE kjp_alter1 = 1;
INSERT INTO nm_kjp_alter_tbl(rg_kjp_gruppenangebote_id, choice_id)
     SELECT id, 2 FROM rg_kjp_gruppenangebote_tbl
      WHERE kjp_alter2 = 1;
INSERT INTO nm_kjp_alter_tbl(rg_kjp_gruppenangebote_id, choice_id)
     SELECT id, 3 FROM rg_kjp_gruppenangebote_tbl
      WHERE kjp_alter3 = 1;


ALTER TABLE rg_kjp_gruppenangebote_tbl
 DROP COLUMN kjp_alter1,
 DROP COLUMN kjp_alter2,
 DROP COLUMN kjp_alter3;



CREATE TABLE nm_nichtkjp_alter_tbl (
    rg_nichtkjp_gruppenangebote_id INTEGER NOT NULL,
    choice_id int4 NOT NULL,
    FOREIGN KEY (rg_nichtkjp_gruppenangebote_id) REFERENCES rg_nichtkjp_gruppenangebote_tbl (id) ON DELETE CASCADE,
    FOREIGN KEY (choice_id) REFERENCES kjp_alter_tbl (id),
    PRIMARY KEY (rg_nichtkjp_gruppenangebote_id, choice_id)
);

INSERT INTO nm_nichtkjp_alter_tbl(rg_nichtkjp_gruppenangebote_id, choice_id)
     SELECT id, 1 FROM rg_nichtkjp_gruppenangebote_tbl
      WHERE nichtkjp_alter1 = 1;
INSERT INTO nm_nichtkjp_alter_tbl(rg_nichtkjp_gruppenangebote_id, choice_id)
     SELECT id, 2 FROM rg_nichtkjp_gruppenangebote_tbl
      WHERE nichtkjp_alter2 = 1;
INSERT INTO nm_nichtkjp_alter_tbl(rg_nichtkjp_gruppenangebote_id, choice_id)
     SELECT id, 3 FROM rg_nichtkjp_gruppenangebote_tbl
      WHERE nichtkjp_alter3 = 1;


 
ALTER TABLE rg_nichtkjp_gruppenangebote_tbl
 DROP COLUMN nichtkjp_alter1,
 DROP COLUMN nichtkjp_alter2,
 DROP COLUMN nichtkjp_alter3;
