BEGIN;

-- 1.0pre4 -> jmd-1.0pre5
-- Typo in der db behoben 

SET ROLE :db_adm;

INSERT INTO db_history (beschreibung, zeitpunkt)
VALUES ('jmd-1.0pre5/04-fallakte.sql', current_timestamp);

-- Issue748
ALTER TABLE master_tbl ADD geburtsland_nennung VARCHAR(60); 
ALTER TABLE master_tbl ADD staatsangehoerigkeit_nennung VARCHAR(60);
ALTER TABLE master_tbl ADD staatsangehoerigkeit_weitere_nennung VARCHAR(60);
ALTER TABLE master_tbl ADD muttersprache_nennung VARCHAR(60); 
ALTER TABLE master_tbl ADD sprache_zuhause_nennung VARCHAR(60); 
ALTER TABLE master_tbl ADD aktuelle_situation_nennung VARCHAR(60);
ALTER TABLE master_tbl ADD aktuelle_massnahme_art_nennung VARCHAR(60); 
ALTER TABLE master_tbl ADD abbruch_durch_nennung VARCHAR(60); 
ALTER TABLE master_tbl ADD gruende_abbruch_cm_nennung VARCHAR(60); 
ALTER TABLE master_tbl ADD ende_inst_einbindung_nennung VARCHAR(60); 

-- Issue830
ALTER TABLE master_tbl ADD nennung_zugang VARCHAR(256);
INSERT INTO zugang_tbl (id, value) VALUES (24, 'Sozialamt');
INSERT INTO zugang_tbl (id, value) VALUES (25, 'Frauenhaus/Zufluchtswohnung');
INSERT INTO zugang_tbl (id, value) VALUES (26, 'Migrationsberatung für Erwachsene');
INSERT INTO zugang_tbl (id, value) VALUES (27, 'Migrantenorganisation');
INSERT INTO zugang_tbl (id, value) VALUES (28, 'Integrationskursträger');
INSERT INTO zugang_tbl (id, value) VALUES (29, 'ArGe/JobCenter');
INSERT INTO zugang_tbl (id, value) VALUES (30, 'Bildungsberatung GF-H');

-- Issue831
INSERT INTO aktuelle_situation_tbl (id, value) VALUES (11, 'Integrationssprachkurs');
INSERT INTO aktuelle_situation_tbl (id, value) VALUES (12, 'Studium');
INSERT INTO aktuelle_situation_tbl (id, value) VALUES (13, 'ESF-BAMF-Kurs');
INSERT INTO aktuelle_situation_tbl (id, value) VALUES (14, 'Praktikum');
UPDATE master_tbl set aktuelle_situation = -3 where aktuelle_situation = 10;

-- Issue832 Option Schwiegerfamilie
ALTER TABLE master_tbl ADD bezugsperson_s INTEGER DEFAULT -1;
ALTER TABLE master_tbl ADD FOREIGN KEY (bezugsperson_s) REFERENCES weitergabe_an_dritte_tbl (id);

-- Issue833
INSERT INTO inst_art_tbl (id, value) VALUES (-2, 'Sonstige');
UPDATE rg_institution_tbl set inst_art = -2 where inst_art = 17;

UPDATE inst_art_tbl set value = 'Frauenhaus/Zufluchtswohnung' where id = 17;
INSERT INTO inst_art_tbl (id, value) VALUES (18, 'ArGe/JobCenter');
INSERT INTO inst_art_tbl (id, value) VALUES (19, 'Integrationskursträger');

-- Issue834
UPDATE aufenthaltsstatus_tbl set value = 'zugewanderte Deutsche mit Migrationshintergrund' where id = 4;
ALTER TABLE master_tbl ADD angaben_aufenthaltsstatus TEXT;
ALTER TABLE aufenthaltsstatus_tbl ALTER value TYPE VARCHAR(54);

-- Issue835 
INSERT INTO sucht_tbl (id, value) VALUES (0, 'Keine Sucht');

-- Issue836 Änderung Sonderschule -> Förderschule
UPDATE aktuelle_schule_tbl set value = 'Förderschule' where id = 1;
UPDATE hoechster_schulabschluss_tbl set value = 'Förderschulabschluss (unterschiedliche Bezeichnungen)' where id = 1;
UPDATE ende_inst_einbindung_tbl set value= 'Förderschule' where id = 1;
INSERT INTO verbleib_jugendliche_tbl (id, value) VALUES (16, 'Förderschule');

-- Issue837 Option "Erwerbstätig und ergänzende Transferleistungen"
-- hinzugefügt.
ALTER TABLE einkommen_familie_tbl ALTER value TYPE VARCHAR(47);
ALTER TABLE einkommen_jugendlicher_tbl ALTER value TYPE VARCHAR(47);
INSERT INTO einkommen_familie_tbl (id, value) VALUES (5, 'Erwerbstätig und ergänzende Transferleistungen');
INSERT INTO einkommen_jugendlicher_tbl (id, value) VALUES (8, 'Erwerbstätig und ergänzende Transferleistungen');

-- Issue839: Modellieren der weiteren sprachen als RG
CREATE TABLE rg_weitere_sprache_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    master_id INTEGER NOT NULL,
    uuid_id CHAR(36),
    kf_erg_weiteresprache_nennung INTEGER DEFAULT -1,
    kf_erg_weiteresprache_nennung_sonstiges VARCHAR(60),
    kf_erg_weiteresprache_a INTEGER DEFAULT -1,
    kf_erg_weiteresprache_b INTEGER DEFAULT -1,
    kf_erg_weiteresprache_c INTEGER DEFAULT -1,
    kf_erg_weiteresprache_d INTEGER DEFAULT -1,
    FOREIGN KEY (master_id) REFERENCES master_tbl (id) ON DELETE CASCADE,
    UNIQUE (uuid_id),
    FOREIGN KEY (kf_erg_weiteresprache_nennung) REFERENCES muttersprache_tbl (id),
    FOREIGN KEY (kf_erg_weiteresprache_a) REFERENCES kf_erg_deutsch_a_tbl (id),
    FOREIGN KEY (kf_erg_weiteresprache_b) REFERENCES kf_erg_deutsch_a_tbl (id),
    FOREIGN KEY (kf_erg_weiteresprache_c) REFERENCES kf_erg_deutsch_a_tbl (id),
    FOREIGN KEY (kf_erg_weiteresprache_d) REFERENCES kf_erg_deutsch_a_tbl (id)
);
CREATE OR REPLACE VIEW rg_weitere_sprache_tbl_view
AS SELECT rg_weitere_sprache_tbl.* FROM rg_weitere_sprache_tbl
    INNER JOIN master_tbl
    ON         rg_weitere_sprache_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2 
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE rg_weitere_sprache_tbl_update_rule AS ON UPDATE TO rg_weitere_sprache_tbl_view
DO INSTEAD UPDATE rg_weitere_sprache_tbl SET
    kf_erg_weiteresprache_nennung = NEW.kf_erg_weiteresprache_nennung,
    kf_erg_weiteresprache_nennung_sonstiges = NEW.kf_erg_weiteresprache_nennung_sonstiges,
    kf_erg_weiteresprache_a = NEW.kf_erg_weiteresprache_a,
    kf_erg_weiteresprache_b = NEW.kf_erg_weiteresprache_b,
    kf_erg_weiteresprache_c = NEW.kf_erg_weiteresprache_c,
    kf_erg_weiteresprache_d = NEW.kf_erg_weiteresprache_d
WHERE id = NEW.id;

CREATE OR REPLACE RULE rg_weitere_sprache_tbl_delete_rule AS ON DELETE TO rg_weitere_sprache_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_weitere_sprache_tbl_insert_rule AS ON INSERT TO rg_weitere_sprache_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_weitere_sprache_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON rg_weitere_sprache_tbl_view TO GROUP :cm_group;
GRANT SELECT ON rg_weitere_sprache_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW rg_weitere_sprache_tbl_anonym_view
AS SELECT
    id,
    master_id,
    uuid_id,
    kf_erg_weiteresprache_nennung,
    NULL::VARCHAR(60) AS kf_erg_weiteresprache_nennung_sonstiges,
    kf_erg_weiteresprache_a,
    kf_erg_weiteresprache_b,
    kf_erg_weiteresprache_c,
    kf_erg_weiteresprache_d FROM rg_weitere_sprache_tbl_view;

CREATE OR REPLACE RULE rg_weitere_sprache_tbl_anonym_delete_rule AS ON DELETE TO rg_weitere_sprache_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_weitere_sprache_tbl_anonym_insert_rule AS ON INSERT TO rg_weitere_sprache_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_weitere_sprache_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON rg_weitere_sprache_tbl_anonym_view TO GROUP :admin_group;

-- Code für die RG
-- PLPython is an untrusted language. -> Need to be postgres.
SET ROLE postgres;

-- DROP FUNCTION get_case_structure(int4);
CREATE OR REPLACE FUNCTION get_case_structure(case_id int4) RETURNS TEXT AS $$

class Node(object):

    def __init__(self, name, id = None, children = []):
        self.name     = name
        self.id       = id
        self.children = children

    def to_json(self, out):
        out.append('{"name":"%s","id":%d' % (self.name, self.id))
        if self.children:
            out.append(',"children":[')
            first = True
            for child in self.children:
                if first: first = False
                else:     out.append(",")
                child.to_json(out)
            out.append("]")
        out.append("}")

    def recursive_build(self, mid, children):
        select = "SELECT id FROM %s WHERE master_id = %d" % (
            self.name, mid)
        ids = [r['id'] for r in plpy.execute(select)]
        for id in ids:
            sub_children = []
            node = Node(self.name, id, sub_children)
            for child in self.children:
                child.recursive_build(id, sub_children)
            children.append(node)

TREE_STRUCTURE = Node('master_tbl', children = [
    Node('rg_institution_tbl'),
    Node('rg_kontaktdaten_tbl'),
    Node('rg_kontaktdaten_sorgeberechtigte_tbl'),
    Node('rg_kinder_tbl'),
    Node('rg_biographie2_tbl'),
    Node('rg_weitere_sprache_tbl'),
    Node('rg_ziele_tbl')
])

r = plpy.execute(
    "SELECT modified, cache FROM case_structure "
    "WHERE master_id = %d" % case_id, 1)

if not r: return ""
r = r[0]

if r['modified']: # need refresh
    children = []
    tree = Node(TREE_STRUCTURE.name, case_id, children)
    for child in TREE_STRUCTURE.children:
        child.recursive_build(case_id, children)
    out = []
    tree.to_json(out)
    cache = "".join(out)
    plan = plpy.prepare(
        "UPDATE case_structure SET modified = false, "
        "cache = $1 WHERE master_id = $2", ["text", "int4"])
    plpy.execute(plan, [cache, case_id])
    return cache

return r['cache']

$$ LANGUAGE plpythonu EXTERNAL SECURITY DEFINER;

-- Continue as db-owner from here
ALTER FUNCTION get_case_structure(int4) OWNER TO :adm_ka_owner;
SET ROLE :adm_ka_owner;

-- Trigger
CREATE OR REPLACE FUNCTION rg_weitere_sprache_tbl_insert_func() RETURNS TRIGGER AS $$
BEGIN
UPDATE case_structure SET modified = true WHERE master_id
IN (
SELECT master_tbl.id FROM rg_weitere_sprache_tbl
INNER JOIN master_tbl ON rg_weitere_sprache_tbl.master_id = master_tbl.id
WHERE rg_weitere_sprache_tbl.id = NEW.id
);
RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_weitere_sprache_tbl_insert_trigger AFTER INSERT ON rg_weitere_sprache_tbl
FOR EACH ROW EXECUTE PROCEDURE rg_weitere_sprache_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_weitere_sprache_tbl_delete_func() RETURNS TRIGGER AS $$
BEGIN
UPDATE case_structure SET modified = true WHERE master_id
IN (
SELECT master_tbl.id FROM rg_weitere_sprache_tbl
INNER JOIN master_tbl ON rg_weitere_sprache_tbl.master_id = master_tbl.id
WHERE rg_weitere_sprache_tbl.id = OLD.id
);
RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_weitere_sprache_tbl_delete_trigger BEFORE DELETE ON rg_weitere_sprache_tbl
FOR EACH ROW EXECUTE PROCEDURE rg_weitere_sprache_tbl_delete_func();

-- Add modified create_rg_weitere_sprache_tbl function to be able to add rg as
-- user postgres. Does not raise ne exception
CREATE OR REPLACE FUNCTION create_rg_weitere_sprache_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
rid integer;
mid integer;
BEGIN
mid := pid;

IF NOT isEditorOrStandin(mid) THEN
--RAISE EXCEPTION 'DS ID not session_user ID';
END IF;

INSERT INTO rg_weitere_sprache_tbl (master_id) VALUES (pid);

SELECT INTO rid currval('rg_weitere_sprache_tbl_id_seq');

IF nuuid IS NOT NULL THEN
UPDATE rg_weitere_sprache_tbl
SET    uuid_id = nuuid
WHERE  id = rid;
ELSE
PERFORM set_uuid('rg_weitere_sprache_tbl', rid);

END IF;

RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION delete_rg_weitere_sprache_tbl(rid integer)
RETURNS void
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
mid integer;
BEGIN
SELECT INTO mid master_id FROM rg_weitere_sprache_tbl WHERE id = rid;

IF NOT isEditorOrStandin(mid) THEN
RAISE EXCEPTION 'DS ID not session_user ID';
END IF;

DELETE FROM rg_weitere_sprache_tbl WHERE id = rid;
END;
$$;

-- Übernahme der alten Einträge in eine RG
-- Für alle Eintrage in der master_tbl
-- Prüfe ob der Eintrag kf_erg_weiteresprache_nennung nicht leer ist.
-- Wenn eintrag nicht leer dann lege für die entsprechende akte 
-- einen neuen rg-eintrag an, und übernehme die werte.
CREATE OR REPLACE FUNCTION insert_rg() RETURNS VOID AS $$
DECLARE
  r RECORD;
  rgid INTEGER;
BEGIN
  FOR r in SELECT id, kf_erg_weiteresprache_nennung, kf_erg_weiteresprache_a,
  kf_erg_weiteresprache_b, kf_erg_weiteresprache_c, kf_erg_weiteresprache_d
  FROM master_tbl LOOP
    IF r.kf_erg_weiteresprache_nennung <> '' THEN
      -- Insert new RG
      rgid = create_rg_weitere_sprache_tbl(r.id, NULL);
      ---- Update values in RG
      UPDATE rg_weitere_sprache_tbl set 
      kf_erg_weiteresprache_nennung = -2,
      kf_erg_weiteresprache_nennung_sonstiges = r.kf_erg_weiteresprache_nennung,
      kf_erg_weiteresprache_a = r.kf_erg_weiteresprache_a,
      kf_erg_weiteresprache_b = r.kf_erg_weiteresprache_b,
      kf_erg_weiteresprache_c = r.kf_erg_weiteresprache_c,
      kf_erg_weiteresprache_d = r.kf_erg_weiteresprache_d
      where id = rgid;
      RAISE NOTICE 'rgid is %', rgid;
    END IF;
  END LOOP;
END;
$$ LANGUAGE plpgsql;
SELECT insert_rg();
DROP FUNCTION insert_rg();

-- Add unmodified create_rg_weitere_sprache_tbl function
CREATE OR REPLACE FUNCTION create_rg_weitere_sprache_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
rid integer;
mid integer;
BEGIN
mid := pid;

IF NOT isEditorOrStandin(mid) THEN
RAISE EXCEPTION 'DS ID not session_user ID';
END IF;

INSERT INTO rg_weitere_sprache_tbl (master_id) VALUES (pid);

SELECT INTO rid currval('rg_weitere_sprache_tbl_id_seq');

IF nuuid IS NOT NULL THEN
UPDATE rg_weitere_sprache_tbl
SET    uuid_id = nuuid
WHERE  id = rid;
ELSE
PERFORM set_uuid('rg_weitere_sprache_tbl', rid);

END IF;

RETURN rid;
END;
$$;

-- Droppen der alten Einträge
ALTER TABLE master_tbl DROP kf_erg_weiteresprache_nennung CASCADE;
ALTER TABLE master_tbl DROP kf_erg_weiteresprache_a CASCADE;
ALTER TABLE master_tbl DROP kf_erg_weiteresprache_b CASCADE;
ALTER TABLE master_tbl DROP kf_erg_weiteresprache_c CASCADE;
ALTER TABLE master_tbl DROP kf_erg_weiteresprache_d CASCADE;
ALTER TABLE master_tbl DROP kf_erg_weiteresprache_gesamt CASCADE;

-- Issue838: Der Abschnitt "Herkunfts- und Muttersprache" entfernt
ALTER TABLE master_tbl DROP kf_erg_muttersprache_a CASCADE;
ALTER TABLE master_tbl DROP kf_erg_muttersprache_b CASCADE;
ALTER TABLE master_tbl DROP kf_erg_muttersprache_c CASCADE;
ALTER TABLE master_tbl DROP kf_erg_muttersprache_d CASCADE;


-- Issue841
ALTER TABLE rg_ziele_tbl DROP ua_uziel1_form CASCADE;
ALTER TABLE rg_ziele_tbl DROP ua_uziel2_form CASCADE;
ALTER TABLE rg_ziele_tbl DROP ua_uziel3_form CASCADE;
DROP TABLE ua_uziel1_form_tbl CASCADE;

-- Issue842
INSERT INTO hoechster_schulabschluss_ausland_anerkannt_tbl (id, value) VALUES (4, 'Teilweise anerkannt');
ALTER TABLE master_tbl DROP hoechster_schulabschluss_ausland_aequi_anerkannt CASCADE;
ALTER TABLE master_tbl DROP hoechster_berufsabschluss_ausland_aequi_anerkannt CASCADE;

-- Issue859
INSERT INTO ende_inst_einbindung_tbl (id, value) VALUES (-2, 'Sonstiges');
UPDATE ende_inst_einbindung_tbl set value = 'Erwerbstätig' where id = 11;
UPDATE ende_inst_einbindung_tbl set value = 'Zivildienst / Wehrpflicht / Freiwilligenjahr' where id = 15;
UPDATE ende_inst_einbindung_tbl set value = 'Studium' where id = 16;
UPDATE ende_inst_einbindung_tbl set value = 'Arbeitslos' where id = 17;
INSERT INTO ende_inst_einbindung_tbl (id, value) VALUES (18, 'Selbstständig');
INSERT INTO ende_inst_einbindung_tbl (id, value) VALUES (19, 'Praktikum');
ALTER TABLE ende_inst_einbindung_tbl ALTER value TYPE VARCHAR(45);

UPDATE master_tbl set aktuelle_situation = -3 where aktuelle_situation in (1,2);
DELETE FROM aktuelle_situation_tbl where id in (1,2);

INSERT INTO aktuelle_situation_tbl (id, value) VALUES (15, 'Förderschule');
INSERT INTO aktuelle_situation_tbl (id, value) VALUES (16, 'Hauptschule');
INSERT INTO aktuelle_situation_tbl (id, value) VALUES (17, 'Realschule');
INSERT INTO aktuelle_situation_tbl (id, value) VALUES (18, 'Gesamtschule');
INSERT INTO aktuelle_situation_tbl (id, value) VALUES (19, 'Gymnasium');
INSERT INTO aktuelle_situation_tbl (id, value) VALUES (20, 'Berufsschule');
INSERT INTO aktuelle_situation_tbl (id, value) VALUES (21, 'Berufsvorbereitungsjahr  (BVJ)');
INSERT INTO aktuelle_situation_tbl (id, value) VALUES (22, 'Berufsgrundbildungsjahr (BGJ)');

-- Neue Views aufsetzen
-- rg_ziele_tbl_view
CREATE OR REPLACE VIEW rg_ziele_tbl_view
AS SELECT rg_ziele_tbl.* FROM rg_ziele_tbl
    INNER JOIN master_tbl
    ON         rg_ziele_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2 
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE rg_ziele_tbl_update_rule AS ON UPDATE TO rg_ziele_tbl_view
DO INSTEAD UPDATE rg_ziele_tbl SET
    fp_ziel = NEW.fp_ziel,
    fp_ziel_sonstiges = NEW.fp_ziel_sonstiges,
    fp_uziel1 = NEW.fp_uziel1,
    fp_uziel1_erreicht = NEW.fp_uziel1_erreicht,
    fp_uziel2 = NEW.fp_uziel2,
    fp_uziel2_erreicht = NEW.fp_uziel2_erreicht,
    fp_uziel3 = NEW.fp_uziel3,
    fp_uziel3_erreicht = NEW.fp_uziel3_erreicht,
    fp_ziel_beschreibung = NEW.fp_ziel_beschreibung,
    fp_leistung_teilnehmer = NEW.fp_leistung_teilnehmer,
    fp_leistung_jmd = NEW.fp_leistung_jmd,
    fp_datum_vereinbarung = NEW.fp_datum_vereinbarung,
    fp_datum_umsetzung = NEW.fp_datum_umsetzung,
    fp_externe_einrichtung = NEW.fp_externe_einrichtung,
    fp_externe_einrichtung_1_name = NEW.fp_externe_einrichtung_1_name,
    fp_externe_einrichtung_1_datum = NEW.fp_externe_einrichtung_1_datum,
    fp_externe_einrichtung_2_name = NEW.fp_externe_einrichtung_2_name,
    fp_externe_einrichtung_2_datum = NEW.fp_externe_einrichtung_2_datum,
    fp_externe_einrichtung_3_name = NEW.fp_externe_einrichtung_3_name,
    fp_externe_einrichtung_3_datum = NEW.fp_externe_einrichtung_3_datum,
    fp_uziel1_angebot = NEW.fp_uziel1_angebot,
    fp_uziel2_angebot = NEW.fp_uziel2_angebot,
    fp_uziel3_angebot = NEW.fp_uziel3_angebot,
    ua_uziel1_art = NEW.ua_uziel1_art,
    ua_uziel1_datum_start = NEW.ua_uziel1_datum_start,
    ua_uziel1_datum_ende = NEW.ua_uziel1_datum_ende,
    ua_uziel2_art = NEW.ua_uziel2_art,
    ua_uziel2_datum_start = NEW.ua_uziel2_datum_start,
    ua_uziel2_datum_ende = NEW.ua_uziel2_datum_ende,
    ua_uziel3_art = NEW.ua_uziel3_art,
    ua_uziel3_datum_start = NEW.ua_uziel3_datum_start,
    ua_uziel3_datum_ende = NEW.ua_uziel3_datum_ende
WHERE id = NEW.id;

CREATE OR REPLACE RULE rg_ziele_tbl_delete_rule AS ON DELETE TO rg_ziele_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_ziele_tbl_insert_rule AS ON INSERT TO rg_ziele_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_ziele_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON rg_ziele_tbl_view TO GROUP :cm_group;
GRANT SELECT ON rg_ziele_tbl_view TO GROUP :admin_group;

-- rg_ziele_tbl_anonym_view
CREATE OR REPLACE VIEW rg_ziele_tbl_anonym_view
AS SELECT
    id,
    master_id,
    uuid_id,
    fp_ziel,
    NULL::VARCHAR(60) AS fp_ziel_sonstiges,
    NULL::VARCHAR(60) AS fp_uziel1,
    fp_uziel1_erreicht,
    NULL::VARCHAR(60) AS fp_uziel2,
    fp_uziel2_erreicht,
    NULL::VARCHAR(60) AS fp_uziel3,
    fp_uziel3_erreicht,
    NULL::TEXT AS fp_ziel_beschreibung,
    NULL::VARCHAR(60) AS fp_leistung_teilnehmer,
NULL::VARCHAR(60) AS fp_leistung_jmd,
fp_datum_vereinbarung,
fp_datum_umsetzung,
fp_externe_einrichtung,
NULL::VARCHAR(60) AS fp_externe_einrichtung_1_name,
fp_externe_einrichtung_1_datum,
NULL::VARCHAR(60) AS fp_externe_einrichtung_2_name,
fp_externe_einrichtung_2_datum,
NULL::VARCHAR(60) AS fp_externe_einrichtung_3_name,
fp_externe_einrichtung_3_datum,
fp_uziel1_angebot,
fp_uziel2_angebot,
fp_uziel3_angebot,
NULL::VARCHAR(60) AS ua_uziel1_art,
ua_uziel1_datum_start,
ua_uziel1_datum_ende,
NULL::VARCHAR(60) AS ua_uziel2_art,
ua_uziel2_datum_start,
ua_uziel2_datum_ende,
NULL::VARCHAR(60) AS ua_uziel3_art,
ua_uziel3_datum_start,
ua_uziel3_datum_ende FROM rg_ziele_tbl_view;

CREATE OR REPLACE RULE rg_ziele_tbl_anonym_delete_rule AS ON DELETE TO rg_ziele_tbl_anonym_view
DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_ziele_tbl_anonym_insert_rule AS ON INSERT TO rg_ziele_tbl_anonym_view
DO INSTEAD NOTHING;

GRANT SELECT ON rg_ziele_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON rg_ziele_tbl_anonym_view TO GROUP :admin_group;

-- master_tbl_view
CREATE OR REPLACE VIEW master_tbl_view
AS SELECT master_tbl.* FROM master_tbl
WHERE
master_tbl.bearbeiter_id = getuserid()
OR master_tbl.id IN (
SELECT nm.master_id from nm_benutzer_master_tbl nm
WHERE nm.benutzer_id IN (
    SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2 
    WHERE nm2.benutzer_id = getuserid()
)
)
OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE master_tbl_update_rule AS ON UPDATE TO master_tbl_view
DO INSTEAD UPDATE master_tbl SET
    phase = NEW.phase,
    jmd_name = NEW.jmd_name,
    mitarbeiter_name = NEW.mitarbeiter_name,
    mitarbeiter_vorname = NEW.mitarbeiter_vorname,
    datum_ea_start = NEW.datum_ea_start,
    zugang = NEW.zugang,
    nennung_zugang = NEW.nennung_zugang,
    war_bereits_kunde = NEW.war_bereits_kunde,
    nennung_einrichtung_cm = NEW.nennung_einrichtung_cm,
    einwilligung = NEW.einwilligung,
    weitergabe_an_dritte = NEW.weitergabe_an_dritte,
    kooperation_mit_dritten = NEW.kooperation_mit_dritten,
    art_begleitung = NEW.art_begleitung,
    datum_ea_ende = NEW.datum_ea_ende,
    datum_cm_start = NEW.datum_cm_start,
    datum_ber_start = NEW.datum_ber_start,
    datum_ber_ende = NEW.datum_ber_ende,
    name = NEW.name,
    vorname = NEW.vorname,
    geburtsname = NEW.geburtsname,
    name_vor_einbuergerung = NEW.name_vor_einbuergerung,
    geburtsdatum = NEW.geburtsdatum,
    geschlecht = NEW.geschlecht,
    geburtsland = NEW.geburtsland,
    geburtsland_nennung = NEW.geburtsland_nennung,
    geburtsort = NEW.geburtsort,
    fuehrerschein = NEW.fuehrerschein,
    familienstand = NEW.familienstand,
    alleinerziehend = NEW.alleinerziehend,
    anzahl_geschwister = NEW.anzahl_geschwister,
    staatsangehoerigkeit = NEW.staatsangehoerigkeit,
    staatsangehoerigkeit_nennung = NEW.staatsangehoerigkeit_nennung,
    staatsangehoerigkeit_weitere = NEW.staatsangehoerigkeit_weitere,
    staatsangehoerigkeit_weitere_nennung = NEW.staatsangehoerigkeit_weitere_nennung,
    einreisedatum = NEW.einreisedatum,
    aufenthaltsstatus = NEW.aufenthaltsstatus,
    angaben_aufenthaltsstatus = NEW.angaben_aufenthaltsstatus,
    muttersprache = NEW.muttersprache,
    muttersprache_nennung = NEW.muttersprache_nennung,
    sprache_zuhause = NEW.sprache_zuhause,
    sprache_zuhause_nennung = NEW.sprache_zuhause_nennung,
    mutter_geburtsland = NEW.mutter_geburtsland,
    vater_geburtsland = NEW.vater_geburtsland,
    wohnsituation = NEW.wohnsituation,
    bezugsperson_a = NEW.bezugsperson_a,
    bezugsperson_b = NEW.bezugsperson_b,
    bezugsperson_c = NEW.bezugsperson_c,
    bezugsperson_d = NEW.bezugsperson_d,
    bezugsperson_e = NEW.bezugsperson_e,
    bezugsperson_s = NEW.bezugsperson_s,
    bezugsperson_f = NEW.bezugsperson_f,
    bezugsperson_g = NEW.bezugsperson_g,
    bezugsperson_h = NEW.bezugsperson_h,
    bezugsperson_i = NEW.bezugsperson_i,
    bezugsperson_j = NEW.bezugsperson_j,
    bezugsperson_k = NEW.bezugsperson_k,
    bezugsperson_l = NEW.bezugsperson_l,
    bezugsperson_m = NEW.bezugsperson_m,
    bezugsperson_n = NEW.bezugsperson_n,
    bezugsperson_o = NEW.bezugsperson_o,
    bezugsperson_p = NEW.bezugsperson_p,
    bezugsperson_q = NEW.bezugsperson_q,
    bezugsperson_r = NEW.bezugsperson_r,
    zugeh_a = NEW.zugeh_a,
    zugeh_b = NEW.zugeh_b,
    zugeh_c = NEW.zugeh_c,
    zugeh_d = NEW.zugeh_d,
    zugeh_e = NEW.zugeh_e,
    soz_engagement = NEW.soz_engagement,
    einkommen_familie = NEW.einkommen_familie,
    einkommen_jugendlicher = NEW.einkommen_jugendlicher,
    geldmittel = NEW.geldmittel,
    schulden = NEW.schulden,
    schulden_beratung = NEW.schulden_beratung,
    psychische_beeintraechtigung = NEW.psychische_beeintraechtigung,
    physische_beeintraechtugung = NEW.physische_beeintraechtugung,
    sucht = NEW.sucht,
    aktuelle_situation = NEW.aktuelle_situation,
    aktuelle_situation_nennung = NEW.aktuelle_situation_nennung,
    aktuelle_schule = NEW.aktuelle_schule,
    aktuelle_schule_klassenstufe = NEW.aktuelle_schule_klassenstufe,
    aktueller_beruf = NEW.aktueller_beruf,
    aktueller_beruf_ausbildungsjahr = NEW.aktueller_beruf_ausbildungsjahr,
    aktuelle_massnahme_art = NEW.aktuelle_massnahme_art,
    aktuelle_massnahme_art_nennung = NEW.aktuelle_massnahme_art_nennung,
    aktuelle_massnahme = NEW.aktuelle_massnahme,
    aktuelle_massnahme_beginn = NEW.aktuelle_massnahme_beginn,
    aktuelle_massnahme_dauer = NEW.aktuelle_massnahme_dauer,
    aktuelle_taetigkeit = NEW.aktuelle_taetigkeit,
    aktuelle_taetigkeit_datum_seit = NEW.aktuelle_taetigkeit_datum_seit,
    aktuelle_arbeitslosigkeit_seit = NEW.aktuelle_arbeitslosigkeit_seit,
    aktuelle_elternzeit_seit = NEW.aktuelle_elternzeit_seit,
    aktueller_zivildienst_seit = NEW.aktueller_zivildienst_seit,
    hoechster_schulabschluss = NEW.hoechster_schulabschluss,
    hoechster_schulabschluss_nennung = NEW.hoechster_schulabschluss_nennung,
    hoechster_schulabschluss_ausland = NEW.hoechster_schulabschluss_ausland,
    hoechster_schulabschluss_ausland_anerkannt = NEW.hoechster_schulabschluss_ausland_anerkannt,
    hoechster_schulabschluss_ausland_land = NEW.hoechster_schulabschluss_ausland_land,
    hoechster_berufsabschluss = NEW.hoechster_berufsabschluss,
    hoechster_berufsabschluss_nennung = NEW.hoechster_berufsabschluss_nennung,
    hoechster_berufsabschluss_ausland = NEW.hoechster_berufsabschluss_ausland,
    hoechster_berufsabschluss_ausland_anerkannt = NEW.hoechster_berufsabschluss_ausland_anerkannt,
    hoechster_berufsabschluss_ausland_land = NEW.hoechster_berufsabschluss_ausland_land,
    integrationskurs = NEW.integrationskurs,
    datum_integrationskurs_ende = NEW.datum_integrationskurs_ende,
    kompetenzfeststellung = NEW.kompetenzfeststellung,
    kf_verfahren_nennung = NEW.kf_verfahren_nennung,
    kf_verfahren = NEW.kf_verfahren,
    kf_erg_natur_a = NEW.kf_erg_natur_a,
    kf_erg_natur_b = NEW.kf_erg_natur_b,
    kf_erg_natur_c = NEW.kf_erg_natur_c,
    kf_erg_natur_d = NEW.kf_erg_natur_d,
    kf_erg_natur_e = NEW.kf_erg_natur_e,
    kf_erg_medien_a = NEW.kf_erg_medien_a,
    kf_erg_medien_b = NEW.kf_erg_medien_b,
    kf_erg_medien_c = NEW.kf_erg_medien_c,
    kf_erg_medien_d = NEW.kf_erg_medien_d,
    kf_erg_medien_e = NEW.kf_erg_medien_e,
    kf_erg_handwerk_a = NEW.kf_erg_handwerk_a,
    kf_erg_handwerk_b = NEW.kf_erg_handwerk_b,
    kf_erg_handwerk_c = NEW.kf_erg_handwerk_c,
    kf_erg_handwerk_d = NEW.kf_erg_handwerk_d,
    kf_erg_methode_a = NEW.kf_erg_methode_a,
    kf_erg_methode_b = NEW.kf_erg_methode_b,
    kf_erg_methode_c = NEW.kf_erg_methode_c,
    kf_erg_methode_d = NEW.kf_erg_methode_d,
    kf_erg_methode_e = NEW.kf_erg_methode_e,
    kf_erg_methode_f = NEW.kf_erg_methode_f,
    kf_erg_methode_g = NEW.kf_erg_methode_g,
    kf_erg_deutsch_a = NEW.kf_erg_deutsch_a,
    kf_erg_deutsch_b = NEW.kf_erg_deutsch_b,
    kf_erg_deutsch_c = NEW.kf_erg_deutsch_c,
    kf_erg_deutsch_d = NEW.kf_erg_deutsch_d,
    kf_erg_sozial_a = NEW.kf_erg_sozial_a,
    kf_erg_sozial_b = NEW.kf_erg_sozial_b,
    kf_erg_sozial_c = NEW.kf_erg_sozial_c,
    kf_erg_sozial_d = NEW.kf_erg_sozial_d,
    kf_erg_sozial_e = NEW.kf_erg_sozial_e,
    kf_erg_sozial_f = NEW.kf_erg_sozial_f,
    kf_erg_sozial_g = NEW.kf_erg_sozial_g,
    kf_erg_sozial_h = NEW.kf_erg_sozial_h,
    kf_erg_sozial_i = NEW.kf_erg_sozial_i,
    kf_erg_sozial_j = NEW.kf_erg_sozial_j,
    kf_erg_selbst_a = NEW.kf_erg_selbst_a,
    kf_erg_selbst_b = NEW.kf_erg_selbst_b,
    kf_erg_selbst_c = NEW.kf_erg_selbst_c,
    kf_erg_selbst_d = NEW.kf_erg_selbst_d,
    kf_erg_selbst_e = NEW.kf_erg_selbst_e,
    kf_erg_selbst_f = NEW.kf_erg_selbst_f,
    kf_erg_selbst_g = NEW.kf_erg_selbst_g,
    kf_erg_selbst_h = NEW.kf_erg_selbst_h,
    kf_erg_selbst_i = NEW.kf_erg_selbst_i,
    kf_erg_selbst_j = NEW.kf_erg_selbst_j,
    kf_erg_selbst_k = NEW.kf_erg_selbst_k,
    kf_erg_leistung_a = NEW.kf_erg_leistung_a,
    kf_erg_leistung_b = NEW.kf_erg_leistung_b,
    kf_erg_leistung_c = NEW.kf_erg_leistung_c,
    kf_erg_leistung_d = NEW.kf_erg_leistung_d,
    kf_erg_leistung_e = NEW.kf_erg_leistung_e,
    kf_erg_leistung_f = NEW.kf_erg_leistung_f,
    kf_erg_leistung_g = NEW.kf_erg_leistung_g,
    kf_erg_leistung_h = NEW.kf_erg_leistung_h,
    kf_erg_leistung_i = NEW.kf_erg_leistung_i,
    kf_erg_leistung_j = NEW.kf_erg_leistung_j,
    kf_erg_leistung_k = NEW.kf_erg_leistung_k,
    datum_cm_ende = NEW.datum_cm_ende,
    art_cm_ende = NEW.art_cm_ende,
    abbruch_durch = NEW.abbruch_durch,
    abbruch_durch_nennung = NEW.abbruch_durch_nennung,
    gruende_abbruch_cm = NEW.gruende_abbruch_cm,
    gruende_abbruch_cm_nennung = NEW.gruende_abbruch_cm_nennung,
    veraenderung_inst_einbindung = NEW.veraenderung_inst_einbindung,
    ende_inst_einbindung = NEW.ende_inst_einbindung,
    ende_inst_einbindung_nennung = NEW.ende_inst_einbindung_nennung,
    ziel1_erreicht = NEW.ziel1_erreicht,
    ziel2_erreicht = NEW.ziel2_erreicht,
    ziel3_erreicht = NEW.ziel3_erreicht,
    datum_verbleib_feststellung = NEW.datum_verbleib_feststellung,
    verbleib_jugendliche = NEW.verbleib_jugendliche,
    verbleib_jugendliche_sonstiges = NEW.verbleib_jugendliche_sonstiges
WHERE id = NEW.id;

CREATE OR REPLACE RULE master_tbl_delete_rule AS ON DELETE TO master_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE master_tbl_insert_rule AS ON INSERT TO master_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON master_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON master_tbl_view TO GROUP :cm_group;
GRANT SELECT ON master_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW master_tbl_anonym_view
AS SELECT
    id,
    uuid_id,
    bearbeiter_id,
    phase,
    NULL::VARCHAR(60) AS jmd_name,
    NULL::VARCHAR(60) AS mitarbeiter_name,
    NULL::VARCHAR(60) AS mitarbeiter_vorname,
    datum_ea_start,
    zugang,
    nennung_zugang,
    war_bereits_kunde,
    NULL::VARCHAR(256) AS nennung_einrichtung_cm,
    einwilligung,
    weitergabe_an_dritte,
    kooperation_mit_dritten,
    art_begleitung,
    datum_ea_ende,
    datum_cm_start,
    datum_ber_start,
    datum_ber_ende,
    NULL::VARCHAR(256) AS name,
    NULL::VARCHAR(256) AS vorname,
    NULL::VARCHAR(256) AS geburtsname,
    NULL::VARCHAR(256) AS name_vor_einbuergerung,
    geburtsdatum,
    geschlecht,
    geburtsland,
    NULL::VARCHAR(60) AS geburtsland_nennung,
    NULL::VARCHAR(60) AS geburtsort,
    NULL::VARCHAR(60) AS fuehrerschein,
    familienstand,
    alleinerziehend,
    anzahl_geschwister,
    staatsangehoerigkeit,
    NULL::VARCHAR(60) AS staatsangehoerigkeit_nennung,
    staatsangehoerigkeit_weitere,
    NULL::VARCHAR(60) AS staatsangehoerigkeit_weitere_nennung,
    einreisedatum,
    aufenthaltsstatus,
    angaben_aufenthaltsstatus,
    muttersprache,
    NULL::VARCHAR(60) AS muttersprache_nennung,
    sprache_zuhause,
    NULL::VARCHAR(60) AS sprache_zuhause_nennung,
    mutter_geburtsland,
    vater_geburtsland,
    wohnsituation,
    bezugsperson_a,
    bezugsperson_b,
    bezugsperson_c,
    bezugsperson_d,
    bezugsperson_e,
    bezugsperson_s,
    bezugsperson_f,
    bezugsperson_g,
    bezugsperson_h,
    bezugsperson_i,
    bezugsperson_j,
    bezugsperson_k,
    bezugsperson_l,
    bezugsperson_m,
    bezugsperson_n,
    bezugsperson_o,
    bezugsperson_p,
    bezugsperson_q,
    bezugsperson_r,
    zugeh_a,
    zugeh_b,
    zugeh_c,
    zugeh_d,
    zugeh_e,
    NULL::VARCHAR(60) AS soz_engagement,
    einkommen_familie,
    einkommen_jugendlicher,
    geldmittel,
    schulden,
    schulden_beratung,
    psychische_beeintraechtigung,
    physische_beeintraechtugung,
    sucht,
    aktuelle_situation,
    NULL::VARCHAR(60) AS aktuelle_situation_nennung,
    aktuelle_schule,
    aktuelle_schule_klassenstufe,
    NULL::VARCHAR(60) AS aktueller_beruf,
    aktueller_beruf_ausbildungsjahr,
    aktuelle_massnahme_art,
    NULL::VARCHAR(60) AS aktuelle_massnahme_art_nennung,
    NULL::VARCHAR(60) AS aktuelle_massnahme,
    aktuelle_massnahme_beginn,
    aktuelle_massnahme_dauer,
    NULL::VARCHAR(60) AS aktuelle_taetigkeit,
    aktuelle_taetigkeit_datum_seit,
    aktuelle_arbeitslosigkeit_seit,
    aktuelle_elternzeit_seit,
    aktueller_zivildienst_seit,
    hoechster_schulabschluss,
    NULL::VARCHAR(60) AS hoechster_schulabschluss_nennung,
    NULL::VARCHAR(60) AS hoechster_schulabschluss_ausland,
    hoechster_schulabschluss_ausland_anerkannt,
    hoechster_schulabschluss_ausland_land,
    hoechster_berufsabschluss,
    NULL::VARCHAR(60) AS hoechster_berufsabschluss_nennung,
    NULL::VARCHAR(60) AS hoechster_berufsabschluss_ausland,
    hoechster_berufsabschluss_ausland_anerkannt,
    hoechster_berufsabschluss_ausland_land,
    integrationskurs,
    datum_integrationskurs_ende,
    kompetenzfeststellung,
    kf_verfahren_nennung,
    kf_verfahren,
    kf_erg_natur_a,
    kf_erg_natur_b,
    kf_erg_natur_c,
    kf_erg_natur_d,
    kf_erg_natur_e,
    kf_erg_medien_a,
    kf_erg_medien_b,
    kf_erg_medien_c,
    kf_erg_medien_d,
    kf_erg_medien_e,
    kf_erg_handwerk_a,
    kf_erg_handwerk_b,
    kf_erg_handwerk_c,
    kf_erg_handwerk_d,
    kf_erg_methode_a,
    kf_erg_methode_b,
    kf_erg_methode_c,
    kf_erg_methode_d,
    kf_erg_methode_e,
    kf_erg_methode_f,
    kf_erg_methode_g,
    kf_erg_deutsch_a,
    kf_erg_deutsch_b,
    kf_erg_deutsch_c,
    kf_erg_deutsch_d,
    kf_erg_sozial_a,
    kf_erg_sozial_b,
    kf_erg_sozial_c,
    kf_erg_sozial_d,
    kf_erg_sozial_e,
    kf_erg_sozial_f,
    kf_erg_sozial_g,
    kf_erg_sozial_h,
    kf_erg_sozial_i,
    kf_erg_sozial_j,
    kf_erg_selbst_a,
    kf_erg_selbst_b,
    kf_erg_selbst_c,
    kf_erg_selbst_d,
    kf_erg_selbst_e,
    kf_erg_selbst_f,
    kf_erg_selbst_g,
    kf_erg_selbst_h,
    kf_erg_selbst_i,
    kf_erg_selbst_j,
    kf_erg_selbst_k,
    kf_erg_leistung_a,
    kf_erg_leistung_b,
    kf_erg_leistung_c,
    kf_erg_leistung_d,
    kf_erg_leistung_e,
    kf_erg_leistung_f,
    kf_erg_leistung_g,
    kf_erg_leistung_h,
    kf_erg_leistung_i,
    kf_erg_leistung_j,
    kf_erg_leistung_k,
    datum_cm_ende,
    art_cm_ende,
    abbruch_durch,
    abbruch_durch_nennung,
    gruende_abbruch_cm,
    NULL::VARCHAR(60) AS gruende_abbruch_cm_nennung,
    veraenderung_inst_einbindung,
    ende_inst_einbindung,
    NULL::VARCHAR(60) AS ende_inst_einbindung_nennung,
    ziel1_erreicht,
    ziel2_erreicht,
    ziel3_erreicht,
    datum_verbleib_feststellung,
    verbleib_jugendliche,
    NULL::VARCHAR(60) AS verbleib_jugendliche_sonstiges FROM master_tbl_view;

CREATE OR REPLACE RULE master_tbl_anonym_delete_rule AS ON DELETE TO master_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE master_tbl_anonym_insert_rule AS ON INSERT TO master_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON master_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON master_tbl_anonym_view TO GROUP :admin_group;

CREATE OR REPLACE RULE master_tbl_anonym_delete_rule AS ON DELETE TO master_tbl_anonym_view
DO INSTEAD NOTHING;

CREATE OR REPLACE RULE master_tbl_anonym_insert_rule AS ON INSERT TO master_tbl_anonym_view
DO INSTEAD NOTHING;

GRANT SELECT ON master_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON master_tbl_anonym_view TO GROUP :admin_group;
-- master_tbl_eval_total_view
CREATE OR REPLACE  VIEW master_tbl_eval_total_view AS
SELECT m.* FROM master_tbl m JOIN ka_status_tbl s
ON m.id = s.master_id
WHERE
    s.status <> 3 AND
    (m.bearbeiter_id = (getuserid())::integer)
    OR pg_has_role('admin','MEMBER');

GRANT SELECT ON master_tbl_eval_total_view TO :cm_group;
GRANT SELECT ON master_tbl_eval_total_view TO :admin_group;

--
-- Name: master_tbl_eval_incm_view; Type: VIEW; Schema: public; Owner: postgres
--

-- master_tbl_eval_incm_view
CREATE OR REPLACE  VIEW master_tbl_eval_incm_view AS
SELECT * FROM master_tbl_eval_total_view
WHERE phase IN (2,3,4,5);

GRANT SELECT ON public.master_tbl_eval_incm_view TO :cm_group;
GRANT SELECT ON public.master_tbl_eval_incm_view TO :admin_group;

-- master_tbl_incm_view
CREATE OR REPLACE  VIEW master_tbl_incm_view AS
SELECT * FROM master_tbl_view
WHERE phase IN (2,3,4,5);

GRANT SELECT ON public.master_tbl_incm_view TO :cm_group;
GRANT SELECT ON public.master_tbl_incm_view TO :admin_group;

--
-- Function to anonymize a case and all of its repeat groups
--
CREATE OR REPLACE FUNCTION anonymize_case(mid int)
RETURNS void AS
$$
BEGIN
    PERFORM anonymize_uuid(mid);
    -- anonymize master table
    UPDATE master_tbl_view SET
        jmd_name = NULL,
        mitarbeiter_name = NULL,
        mitarbeiter_vorname = NULL,
        nennung_einrichtung_cm = NULL,
        name = NULL,
        vorname = NULL,
        geburtsname = NULL,
        name_vor_einbuergerung = NULL,
        geburtsland_nennung = NULL,
        geburtsort = NULL,
        fuehrerschein = NULL,
        staatsangehoerigkeit_nennung = NULL,
        staatsangehoerigkeit_weitere_nennung = NULL,
        muttersprache_nennung = NULL,
        sprache_zuhause_nennung = NULL,
        soz_engagement = NULL,
        aktuelle_situation_nennung = NULL,
        aktueller_beruf = NULL,
        aktuelle_massnahme_art_nennung = NULL,
        aktuelle_massnahme = NULL,
        aktuelle_taetigkeit = NULL,
        hoechster_schulabschluss_nennung = NULL,
        hoechster_schulabschluss_ausland = NULL,
        hoechster_berufsabschluss_nennung = NULL,
        hoechster_berufsabschluss_ausland = NULL,
        gruende_abbruch_cm_nennung = NULL,
        ende_inst_einbindung_nennung = NULL,
        verbleib_jugendliche_sonstiges = NULL
    WHERE id = mid;

    -- anonymize repeat groups
    UPDATE rg_institution_tbl_view SET
        inst_betreuende_stelle = NULL,
        inst_strasse = NULL,
        inst_strassenr = NULL,
        inst_plz = NULL,
        inst_ort = NULL,
        inst_person_name = NULL,
        inst_person_vorname = NULL,
        inst_vorwahl = NULL,
        inst_telefon = NULL,
        inst_email = NULL
    WHERE master_id = mid;

    UPDATE rg_kontaktdaten_tbl_view SET
        adresse_strasse = NULL,
        adresse_strassenr = NULL,
        adresse_plz = shorten_value(adresse_plz, 3),
        adresse_ort = NULL,
        vorwahl = NULL,
        telefon = NULL,
        mobilfunknummer = NULL,
        email = NULL
    WHERE master_id = mid;

    UPDATE rg_kontaktdaten_sorgeberechtigte_tbl_view SET
        name_sorge = NULL,
        vorname_sorge = NULL,
        vorwahl_sorge = NULL,
        telefon_sorge = NULL,
        mobilfunknummer_sorge = NULL,
        email_sorge = NULL
    WHERE master_id = mid;

    UPDATE rg_biographie2_tbl_view SET
        biographie_anmerkung = NULL
    WHERE master_id = mid;

    UPDATE rg_weitere_sprache_tbl_view SET
        kf_erg_weiteresprache_nennung_sonstiges = NULL
    WHERE master_id = mid;

    UPDATE rg_ziele_tbl_view SET
        fp_ziel_sonstiges = NULL,
        fp_uziel1 = NULL,
        fp_uziel2 = NULL,
        fp_uziel3 = NULL,
        fp_ziel_beschreibung = NULL,
        fp_leistung_teilnehmer = NULL,
        fp_leistung_jmd = NULL,
        fp_externe_einrichtung_1_name = NULL,
        fp_externe_einrichtung_2_name = NULL,
        fp_externe_einrichtung_3_name = NULL,
        ua_uziel1_art = NULL,
        ua_uziel2_art = NULL,
        ua_uziel3_art = NULL
    WHERE master_id = mid;

END;
$$ LANGUAGE plpgsql VOLATILE SECURITY DEFINER;

REVOKE ALL ON FUNCTION anonymize_case(int) FROM public;
GRANT EXECUTE ON FUNCTION anonymize_case(int) TO GROUP :admin_group;

-- Finish
SET ROLE postgres;
COMMIT;
