## -*- coding: utf-8 -*-
<%inherit file="base.mako" />

<%include file="svg_icons/svg_icons.mako"/>

<%def name="buildStartMenu()">
  % if h.hasRole(['cm', 'admin']):
    <div class="collapse navbar-collapse" id="navbarsExampleDefault">
      <ul class="navbar-nav mr-auto">
        % if (h.getLogin() != 'adm'):
          <li class="nav-item dropdown" id="navItem">
            <a class="nav-link dropdown-toggle" href="${h.url('/')}"
               id="navbarDropdown" role="button"
               data-toggle="dropdown" aria-haspopup="true"
               aria-expanded="false"
               onclick="return checkModificationLink('${h.url('/')}');">
              ${_('Information')}
            </a>
            <div class="dropdown-menu" aria-labelledby="navbarDropdown">
              <a class="dropdown-item" href="${h.url('/')}"
                  id="blackBoard" onclick="return checkModification();">
                ${_('Black Board')}
              </a>
              ## APPOINTMENTS
              % if g.mpuls_config.is_enabled('module', 'appointments'):
                <a class="dropdown-item"
                   href="${h.url(controller='appointment', action='overview')}"
                   id="appointmentOverview"
                   onclick="return checkModification();">
                  % if h.hasRole(['admin']):
                    ${_('Events')}
                  % else:
                    ${_('Events / FollowUps')}
                  % endif
                </a>
                <a class="dropdown-item"
                   href="${h.url(controller='appointment',
                                 action='reminder_overview')}"
                   id="reminderOverview" onclick="return checkModification();">
                  ${_('Reminders')}
                </a>
              % endif
              <div class="dropdown-divider"></div>
              % if g.mpuls_config.is_enabled('module', 'documents'):
                <a class="dropdown-item"
                   href="${h.url(controller='document',
                                 action='globalOverview')}"
                   id="documentGlobalOverview"
                   onclick="return checkModification();">
                  ${_('JMD-wide Documents')}
                </a>
              % endif
              % if h.hasRole(['cm']):
                <a class="dropdown-item"
                   href="${h.url(controller='userdocument', action='overview')}"
                   id="documentUserOverview"
                   onclick="return checkModification();">
                  ${_('My Documents')}
                </a>
              % endif
              % if g.mpuls_config.is_enabled('module', 'casemanagement') and h.hasRole(['cm']):
                <a class="dropdown-item"
                   href="${h.url(controller='privacy',
                                 action='listGenericStatements')}"
                   id="listGenericStatements"
                   onclick="return checkModification();">
                  ${_('Avaliable statements')}
                </a>
              % endif
	      <div class="dropdown-divider"></div>
		<a class="dropdown-item"
		    href="${h.url(controller='help', action='index')}"
           	    onclick="return checkModification();">
           	  ${_('Help')}
		</a>
		<a class="dropdown-item"
		   href="${h.url(controller='info', action='index')}"
                   onclick="return checkModification();"
                   id="info">
                   ${_('About i-mpuls JMD')}
                </a>
            </div>
          </li>
          <li class="nav-item dropdown" id="navItem">
            % if g.mpuls_config.is_enabled('module', 'casemanagement'):
            <%
               id=''
               if session.get('casebundle'):
                   id = str(session.get('casebundle').case_list[-1])
               elif session.get('case'):
                   id = str(session.get('case').id)

               if id:
                   overview_url = h.url(controller='case_overview',
                                        action='overview', anchor=id)
               else:
                   overview_url = h.url(controller='case_overview',
                                        action='overview')
            %>
            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown"
               role="button" data-toggle="dropdown" aria-haspopup="true"
               aria-expanded="false"
               onclick="return checkModificationLink(
                  '${overview_url}');">
              ${_('Case documents	')}
            </a>
            <div class="dropdown-menu" aria-labelledby="navbarDropdown">
              ## casemanagement
              <a class="dropdown-item"
                 href="${overview_url}"
                 id="caseoverviewOverview"
                 onclick="return checkModification();">
                ${_('case documents overview')}
              </a>
              % if h.hasRole(['cm']):
                % if g.mpuls_config.is_enabled('case-module', 'create'):
                  <a class="dropdown-item"
                     href="${h.url(controller='case', action='new')}"
                     id="caseNew" onclick="return checkModification();">
                    ${_('New case document')}
                  </a>
                % endif
                % if g.mpuls_config.is_enabled('case-module', 'import'):
                  <a class="dropdown-item"
                     href="${h.url(controller='case', action='importCase')}"
                     id="caseImportCase" onclick="return checkModification();">
                    ${_('Import case document')}
                  </a>
                % endif
              % endif
            </div>
          % endif
          </li>
          % if g.mpuls_config.is_enabled('module', 'evaluation'):
            <li id="navItem" class="nav-item dropdown">
              <a class="nav-link dropdown-toggle" href="#"
                 id="navbarDropdown" role="button" data-toggle="dropdown"
                 aria-haspopup="true" aria-expanded="false"
                 onclick="return checkModificationLink('${h.url('/evaluate/evaluate/1')}');">
                ${_('Evaluations')}
              </a>
              <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                ${self.buildEvaluations()}
              </div>
            </li>
          % endif
        % endif
        % if g.mpuls_config.is_enabled('module', 'agency-overview'):
          <li id="navItem" class="nav-item dropdown">
            <a class="nav-link dropdown-toggle" href="#"
               id="navbarDropdown" role="button" data-toggle="dropdown"
               aria-haspopup="true" aria-expanded="false"
               onclick="return checkModificationLink('${h.url(controller='evaluation_overview', action='index')}');">
              ${_('Overview')}
            </a>
            <div class="dropdown-menu" aria-labelledby="navbarDropdown">
              <a class="dropdown-item"
                 href="${h.url(controller='evaluation_overview', 
                               action='index')}"
                 id="evaluationOverviewIndex"
                 onclick="return checkModification();">
                ${_('Agency')}
              </a>
            </div>
          </li>
        % endif
        % if h.hasRole(['admin']) and g.mpuls_config.is_enabled('module', 'administration'):
          <li id="navItem" class="nav-item dropdown">
            <a class="nav-link dropdown-toggle" href="#"
               id="navbarDropdown" role="button" data-toggle="dropdown"
               aria-haspopup="true" aria-expanded="false"
               onclick="return checkModificationLink('${h.url(controller='administration', action='overviewUser')}');">
              ${_('Administration')}
            </a>
            <div class="dropdown-menu" aria-labelledby="navbarDropdown">
              <a class="dropdown-item"
                 href="${h.url(controller='administration',
                               action='overviewUser')}"
                 id="administrationOverviewUser"
                 onclick="return checkModification();">
                ${_('User')}
              </a>
              % if (h.getLogin() != 'adm'):
                % if not g.mpuls_config.is_enabled('module', 'agency-overview'):
                  <a class="dropdown-item"
                     href="${h.url(controller='administration',
                                   action='overviewUserGroups')}"
                     id="administrationOverviewUserGroups"
                     onclick="return checkModification();">
                    ${_('Usergroup')}
                  </a>
                % endif
              % endif
      		  <a class="dropdown-item"
         		href="${h.url(controller='jmdstruktur', action='permission')}"
         		onclick="return checkModification();"
         		class="dataset_permissions">
         	     ${_('User permissions')}
      		  </a>
              <a class="dropdown-item"
                 href="${h.url(controller='settings', action='index')}"
                 id="settings" onclick="return checkModification();">
                ${_('Settings')}
              </a>
            </div>
          </li>
        % endif
      </ul>
      <ul class="navbar-nav ml-auto">
         <li class="nav-item">
            <div class="btn-group dropdown">
              <button type="button" class="btn btn-outline-primary" disabled title="Fallaktenteil" id="ft">
                Fallaktenteil
              </button>
              ## Display switch to other datasets only if available and permitted
              <%include file="switch_to_other_datasets.mako" />
            </div>
         </li>
         <li class="nav-link">
	 % if c.status_msg:
                <span class="redcolor">${c.status_msg}</span>
            % else:
            <div class="rounded bg-gradient-4 borderCountdown text-center form-inline" title="${_('Logouttime')}">
              <svg class="svg-icon-disabled pr-1" role="img">
                <use xlink:href="#clock"></use>
              </svg>
              <div id="simpleCountdown" class=""></div>
            </div>
                <script>
                    sc_init_simple_countdown(${ h.get_countdowntime() },
                                             180,
                                             "${_('EXPIRED')}"
                                             );
                </script>
            % endif
         </li>
         <li class="nav-item">
          % if g.mpuls_config.is_enabled('module', 'administration'):
          <a class="nav-link" href="${h.url(controller='usersettings', action='showSettings')}"
             id="usetSettingsShowSettings" title="${_('User')}"
             onclick="return checkModification();">
            <svg class="svg-icon" aria-labelledby="title" role="img">
              <title id="title">${_('User')}</title>
              <use xlink:href="#user"></use>
            </svg></a>
            ${self.buildStatusBar()}
        </li>
        % endif
        <li class="nav-item">
        <a class="nav-link" title="${_('Logout')}" href="${h.url(controller='auth', action='logout')}"
           id="logout"
           onclick="return checkModification();">
          <svg class="svg-icon svg-warning" aria-labelledby="title" role="img">
            <title id="title">${_('Logout')}</title>
            <use xlink:href="#power-off"></use>
          </svg>
        </a>
        </li>
      </ul>
    </div>
  % endif
</%def>

<%def name="buildStatusBar()">
  <div id="statusbar" class="text-muted">
    % if h.getLogin() != 'adm':
        <strong>${h.getRole()}</strong>
    % else:
        <strong>adm</strong> (initiale Anmeldekennung)
    % endif
  </div>
</%def>

<%def name="sidebar()">
</%def>

<%def name="buildInfofield1()">
</%def>

<%def name="buildInfofield2()">
</%def>

<%def name="buildPrivacyfield()">
</%def>

<%def name="buildIco()">
  <span class="menuico"> &gt;&gt;</span>
</%def>

<%def name="buildNavigation()">
</%def>


<%def name="buildEvaluations()">
  % for eval in g.mpuls_config.get('evaluations', 'enabled'):
    % if h.can_use_evaluation(eval):
      <a class="dropdown-item"
         href="${h.url(controller='evaluate', action='evaluate',
                       id=eval.get('id'))}"
         id="evaluateEvaluate"
         onclick="return checkModification();">${eval.get('name')}</a>
    % endif
  % endfor
</%def>

<%def name="buildFormErrors(labels=None)">
  <% formular_labels = labels or {} %>
  % if len(c.form_errors) > 0:
    <div id="alert" class="alert alert-danger" role="alert">
      <h4><a name="error_list">${_('Wrong formular input')}</a></h4>
      <ul>
        % for key, value in c.form_errors.iteritems():
          <li>${_(formular_labels.get(key, '%s' % key))}: ${value}</li>
        % endfor
      </ul>
    </div>
  % endif
</%def>

<%def name="buildContentHeader()">
  ${self.buildUeberschrift()}
  ${self.buildModusfield()}
</%def>

<%def name="buildUeberschrift()">
</%def>

<%def name="buildModusfield()">
</%def>

% if h.hasRole(['admin']):
<nav class="navbar navbar-expand-xl navbar-light fixed-top shadow-sm bg-white"
     id="navbar">
  <a class="navbar-brand" href="${h.url('/')}"
     onclick="return checkModification();">
    <img src="${h.url('/images/logos/logo_ka_60.jpg')}"
         title="JMD" alt="${_('Logo agency')}">
  </a>
  <button class="navbar-toggler" type="button" data-toggle="collapse"
          data-target="#navbarsExampleDefault"
          aria-controls="navbarsExampleDefault" aria-expanded="false"
          aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>
  ${self.buildStartMenu()}
</nav>
% endif
% if h.hasRole(['cm']):
<nav class="navbar navbar-expand-lg navbar-light fixed-top shadow-sm bg-white"
     id="navbar">
  <a class="navbar-brand" href="${h.url('/')}"
     onclick="return checkModification();">
    <img src="${h.url('/images/logos/logo_ka_60.jpg')}"
         title="JMD" alt="${_('Logo agency')}">
  </a>
  <button class="navbar-toggler" type="button" data-toggle="collapse"
          data-target="#navbarsExampleDefault"
          aria-controls="navbarsExampleDefault" aria-expanded="false"
          aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>
  ${self.buildStartMenu()}
</nav>
% endif

<main class="container-fluid" id="main-container">
    <div class="row">
        ${self.sidebar()}
        <div id="content" class="col-md order-first">
              ${next.buildNavigation()}
              ${self.buildContentHeader()}
              % if c.success_text:
                <div id="alert" class="alert alert-success" role="alert">
                  ${c.success_text}
                   <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                      <span aria-hidden="true">&times;</span>
                   </button>
                </div>
              % endif
              ${self.body()}
        </div>
    </div>
</main>
