## -*- coding: utf-8 -*-
<%! import mpulsweb.lib.helper.filters as F %>
<%inherit file="main.mako" />

<%def name="title()">
    ${h.get_app_title()} - ${_('Loginpage')}
</%def>

## Render attribute
<%def name="maybeattr(attrname, cond)">
% if cond:
${attrname}
% endif
</%def>

## Render an option for a choice field
<%def name="option(value, desc, selected)">
<option value="${value}" ${maybeattr("selected", selected)}>${desc}</option>
</%def>


<h2 class="card-title">${_('%s login') % h.get_app_title()}</h2>

  % if c.login_failed:
    <div class="alert alert-danger" role="alert">
      <a name="error_list">
      ${_('Wrong Input')}</a>: ${_('Login or Password not correct')}
    </div>
  % endif

  <p>
    <strong>${_('Agency')}: ${h.getKAName()}</strong><br>
    ${_('Please enter identifier and password to login.')}
  </p>

  <form name="login" action="${h.url(controller='auth', action='loginAction')}" 
  accept-charset="UTF-8" method="POST">
    ${ h.csrf_token() }
    <div class="form-group col-md-6">
      <label for="username">${_('Identifier:')}</label>
       <input id="username" type="text" name="username" maxlength="64"
              class="form-control">
    </div>

    <div class="form-group col-md-6">
      <label for="password">${_('Password:')}</label>
      <input type="password" id="password" name="password"
              class="form-control">
      <input type="checkbox" onclick="toggle_password()"
             id="password_toggle">
      <label class="form-check-label" for="password_toggle">
             ${_('Show Password')}
      </label>
    </div>

    ## This additional selection field for choosing the DB to connect to will
    ## be available as soon as there are defined databases in the dblist json
    ## file. Note that the variable c.filter is optional and defaults to None
    ## which means that no filtering is done. c.filter must be a compiled regular
    ## expression.
    % if len(h.get_db_selectionlist()) > 0 and g.mpuls_config.is_enabled('common', 'showagencychooser'):
    <div class="form-group col-md-6">
      <label for="dbname">${_('Agency')}:</label>
      <select name='dbname' size=1 class="form-control">
      <% dbs = h.get_db_selectionlist() %>
      % for db in h.get_sorted_db_from_selectionlist(c.filter):
           ${option(db, dbs.get(db).get('measure_name'), db == c.dbname)}
      % endfor
      </select>
    </div>
    % endif
    <div class="form-group col-md-6">
      <button type="submit" class="btn btn-primary" name="authform"
        >${_('Login button')}</button>
    </div>
  </form>

<script>
// Simple toggle as illustrated by
// https://www.w3schools.com/howto/howto_js_toggle_password.asp
function toggle_password() {
  var x = document.getElementById("password");
  if (x.type === "password") {
    x.type = "text";
  } else {
    x.type = "password";
  }
}
</script>
