## -*- coding: utf-8 -*-
<%inherit file="../main.mako" />
<%!  import mpulsweb.lib.helper.filters as F %>

<%def name="title()">
    ${h.get_app_title()} - ${_('Case documents overview')}
</%def>

<div id="content_ueberschrift" class="col-md"><h3>${_('Case documents overview')}</h3></div>

<div class="form col-md">
  % if h.hasRole(['admin']):
   <!-- <p>${_('List all case documents of the organisation or the user')}</p>-->
  % endif

  % if h.hasRole(['cm']):
   <!-- <p>${_('List all cases of this user')}</p>-->
  %endif

  <%include file="/casemanagement/search.mako" />

  %if c.available_overviews:
  <div class="menu">
    <ul class="nav nav-tabs">
      % for overview in c.available_overviews:
      <li class="nav-item">
        <% active_css = "active" if overview.id == c.overview_id else "" %>
        <a class="nav-link ${active_css}"
           href="${h.url(controller='case_overview', action='select_overview', id=overview.id)}"
           >${ F.shorten(overview.name, 60) }</a>
      </li>
      % endfor
      <li class="nav-item mr-auto">
        <form role="button" method="POST"
              action="${h.url(controller='customoverview', action='new')}">
          ${ h.csrf_token() }
          <input type="hidden" name="backlink" value="case_overview">
          <button title="${_('New configuration')}" class="btn btn-sm icon-btn">
            <svg class="svg-icon" aria-labelledby="title" role="img">
              <title id="title">${_('New configuration')}</title>
              <use xlink:href="#plus-circle-solid" />
            </svg>
          </button>
        </form>
      </li>
      <a href="${h.url(controller='customoverview', action='overview')}" class="btn btn-outline-primary btn-sm">${_('Manage custom overviews')}</a>
    </ul>

  </div>
  %endif
  ${ungettext('%s case was found.', '%s cases where found.', c.count_all) % c.count_all}
  <form action="${h.url(controller='case_bundle', action='bundleAction')}"
        method="POST">
  ${ h.csrf_token() }
  <%include file="./caselist.mako" />
  % if g.mpuls_config.is_enabled('case-module', 'casebundle'):
    <input type="hidden" name="all_ids" value="${c.all_ids}">
    <div class="form-group d-print-none">
      <select class="custom-select col-3" name="action" 
                                             title="${_('Actions')}">
        <option value="no_action">${_('No action')}</option>
        % if h.hasRole(['admin']):
          <option value="delete">${_('Delete')}</option>
          % if g.mpuls_config.is_enabled('case-module', 'anonymize'):
            <option value="anonymize">${_('Anonymize')}</option>
          % endif
          <option value="restore">${_('Restore')}</option>
          % if g.mpuls_config.is_enabled('case-module', 'organisation'):
            <option value="transfer">${_('Transfer editing')}</option>
          % endif
        % endif
        % if h.hasRole(['cm']):
          % if g.mpuls_config.is_enabled('case-module', 'anonymize'):
            <option value="markanonymize">${_('Mark anonymize')}</option>
          % endif
          <option value="markdelete">${_('Mark for deletion')}</option>
        % endif
        % if h.hasRole(['admin', 'cm']):
          % if g.mpuls_config.is_enabled('case-module', 'organisation'):
            <option value="standin">${_('Set standin')}</option>
          % endif
        % endif
        % if g.mpuls_config.is_enabled('case-module', 'exportXLS'):
          <option value="exportXLS">${_('Export as XLS')}</option>
        % endif
        % if g.mpuls_config.is_enabled('case-module', 'exportEXLS'):
          <option value="exportEXLS">${_('Export as XLS without keys')}</option>
        % endif
        % if g.mpuls_config.is_enabled('case-module', 'exportXML'):
          <option value="exportXML">${_('Export as XML')}</option>
        % endif
        % if g.mpuls_config.is_enabled('case-module', 'exportCSV'):
          <option value="exportCSV">${_('Export as CSV')}</option>
        % endif
        % if g.mpuls_config.is_enabled('case-module', 'formletter'):
          % for l in g.mpuls_config.get('case', 'formletter'):
            <option value="formletter:${l.get('id')}">${l.get('name')}</option>
          % endfor
        % endif
        % if g.mpuls_config.is_enabled('module', 'evaluation') \
          and len(g.mpuls_config.get('evaluations', 'enabled')) > 0 \
          and not c.hide_evaluation:
          <option value="evaluate">${_('Evaluate')}</option>
        % endif
        ${self.render_additional_exports()}
      </select>
      <input class="btn btn-primary" type="submit" 
                                               value="${_('submit action')}">
    </div>
  % endif
  </form>
</div>

