## -*- coding: utf-8 -*-
<%inherit file="../main.mako" />
<%!  import mpulsweb.lib.helper.filters as F %>

<div>
<div class="row">
  <div class="col-auto" id="content_ueberschrift">
  	<h3>${_('Manage custom overviews')}</h3>
  </div>
  <div class="col modusfield">
    <a title="${_('Case document overview')}" href="${h.url(controller='case_overview', action='overview')}">
      <svg class="svg-icon" aria-labelledby="title" role="img">
        <title id="title">${_('Case document overview')}</title>
        <use xlink:href="#arrow-circle-left" />
      </svg>
    </a>
    <a title="${_('New configuration')}"
       href="${h.url(controller='customoverview', action='new')}">
      <svg class="svg-icon" aria-labelledby="title" role="img">
        <title id="title">${_('New configuration')}</title>
        <use xlink:href="#plus-circle-solid" />
      </svg>
    </a>
  </div>
</div>

<div class="table-responsive">
  <table class="table table-sm table-hover custom-table-striped">
    <thead>
    <tr>
      <th scope="col" class="table_width_filename">
        ${_('Name')}
      </th>
      <th scope="col" class="actions">
        ${_('Actions')}
      </th>
    </tr>
    </thead>
    <tbody>
  % if len(c.overviews) > 0:
    % for num, overview in enumerate(c.overviews):
    <tr class="clickable-row" data-href="${h.url(controller='customoverview', action='edit', id=overview.id)}">
      <td>
        ${ F.shorten(overview.name, 60) }
      </td>
      <td class="actions">
        <a title="${_('Delete')}" href="${h.url(controller='customoverview', action='delete', id=overview.id, confirmed=0)}">
          <svg class="svg-icon svg-warning" aria-labelledby="title" role="img">
            <title id="title">${_('Delete')}</title>
            <use xlink:href="#delete" />
          </svg>
        </a>
      </td>
    </tr>
    % endfor
  % else:
    <tr>
      <td colspan="3">
        ${_('No overview configurations found')}
      </td>
      <td></td>
    </tr>
  % endif
    </tbody>
  </table>
</div>
