<%!
import mpulsweb.model.appointment
%>
<%inherit file="/appointments/remindlist_body.mako" />
<%def name="showAppointmentActions(appointment, show_set_done=False)">
 % if appointment.type == mpulsweb.model.appointment.APPOINTMENT_REMINDER:
  % if show_set_done:
    <form role="button"
          action="${h.url(controller='appointment', action='set_done',
                 id=appointment.id)}"
          method="POST">
      ${ h.csrf_token() }
      % if c.set_done_backlink:
        <input type="hidden" name="backlink" value="${c.set_done_backlink}">
      % endif
      <button title="${_('Set Done')}" class="btn btn-sm icon-btn">
          <svg class="svg-icon" aria-labelledby="title" role="img">
             <title id="title">${_('Set Done')}</title>
             <use xlink:href="#check" />
          </svg>
      </button>
    </form>
  % endif
% endif

</%def>
<%def name="showKeepActiveActions(appointment)">
  % if appointment.type != mpulsweb.model.appointment.APPOINTMENT_REMINDER:
    <% sm = g.case_factory.get_state_machine() %>
    % if g.mpuls_config.is_enabled('case-module', 'anonymize'):
      % if appointment.phase and appointment.phase in sm.get_end_state_ids():
        % if c.set_done_backlink == "reminder_overview":
          <% mark_anonymize_action = 'markForAnonymizeFromReminderOverview' %>
        % else:
          <% mark_anonymize_action = 'markForAnonymizeFromBlackboard' %>
        % endif
        <a role="button" title="${_('Anonymize case document')}"
           href="${h.url(controller='case', action=mark_anonymize_action,
                 id=appointment.case_id, confirmed=0)}">
           <svg class="svg-icon svg-warning" aria-labelledby="title" role="img">
             <title id="title">${_('Anonymize case document')}</title>
             <use xlink:href="#anonymise" />
           </svg>
         </a>
      % endif
    % endif
    <a role="button" title="${_('Keep longer activated')}"
      href="${h.url(controller='case', action='keepActive', id=appointment.case_id, confirmed=0)}">
      <svg class="svg-icon" aria-labelledby="title" role="img">
         <title id="title">${_('Keep longer activated')}</title>
         <use xlink:href="#refresh" />
      </svg>
    </a>
  % endif
</%def>

<%def name="showAppointmentURL(appointment)">
% if appointment.type in [1]:
  "${h.url(controller='caseappointment', action='show', id=appointment.id, confirmed=0)}"
% else:
  "${h.url(controller='case', action='select', id=appointment.case_id, confirmed=0)}"
% endif
</%def>
