<%inherit file="/casemanagement/main.mako" />
<%!  import mpulsweb.lib.helper.filters as F %>
<%namespace file="../documents/overview.mako" import="overview_table"/>

<%def name="buildNavipath()">
  ${parent.buildNavipath()}
  <li><a href="${h.url(controller='case', action='select', id=session.get('case').id, confirmed=1)}">${_('Selected case documents')}</a></li>
  <li><a href="${h.url(controller='logbook', action='index', id=session.get('case').id)}">${_('Logbook')}</a></li>
  <li><a href="#"></a>${_('Logbook entry')}</a></li>

</%def>
<div class="overviewpage">
  <div id="content_header">
    <div class="row">
      <div id="content_ueberschrift" class="col-auto">
        <h3>${_('Logbook entry')}</h3>
      </div>
      <div class="col modusfield d-print-none">
        % if h.hasRole(['cm']) and c.entry.is_editable_in_case(session['case']):
          <a title="${_('Edit entry')}" href="${h.url(controller='logbook', action='edit', id=c.entry.id)}">
            <svg class="svg-icon" aria-labelledby="title" role="img">
              <title id="title">${_('Edit entry')}</title>
              <use xlink:href="#edit" />
            </svg>
          </a>
        % endif
        <a title="${_('Back to: Logbook')}" href="${h.url(controller='logbook', action='index', id=session.get('case').id)}">
          <svg class="svg-icon" aria-labelledby="title" role="img">
            <title id="title">${_('Back to: Logbook')}</title>
            <use xlink:href="#arrow-circle-left" />
          </svg>
        </a>
      </div>
    </div>
  </div>

  <div class="table-responsive">
    <table class="table table-sm table-borderless summary">
        <tbody>
            <tr>
                <td>Datum</td>
                <td>${c.entry.getDate()} ${c.entry.getTime()}</td>
            </tr>
            <tr>
                <td>${_('Editor')}</td>
                <td>${c.entry.getEditor()}</td>
            </tr>
            <tr>
                <td>${_('Type')}</td>
                <td>${c.entry.getKindsAsText()}</td>
            </tr>
            <tr>
                <td>${_('Duration in minutes')}</td>
                <td>${c.entry.getDuration('-/-')}</td>
            </tr>
            <tr>
                <td>${_('Note')}</td>
                <td>${h.literal(c.entry.getNotice()) | F.NA}</td>
            </tr>
        </tbody>
    </table>
  </div>


  <div class="row">
    <div class="col-auto">
      <h4 class="text-muted">${_('Attachment overview')}</h4>
    </div>
    % if h.hasRole(['cm']) and c.entry.is_editable_in_case(session['case']):
      <div class="col modusfield pt-0 d-print-none">
        <a title="${_('Add attachment')}" href="${h.url(controller='logbook', action='newDocument',
                         id=c.entry.id)}">
          <svg class="svg-icon" aria-labelledby="title" role="img">
            <title id="title">${_('Add attachment')}</title>
            <use xlink:href="#plus-circle-solid" />
          </svg>
        </a>
      </div>
    % endif
  </div>
  ${overview_table(show_url, actions)}
</div>


<%def name="show_url(doc)">
${h.url(controller='logbook', action='showDocument', id=doc.id, url=doc.getName())}
</%def>

<%def name="actions(doc)">
% if h.hasRole(['cm']) and c.entry.is_editable_in_case(session['case']):
  <a title="${_('Rename')}" href="${h.url(controller='logbook', action='renameDocument', id=doc.id)}">
    <svg class="svg-icon" aria-labelledby="title" role="img">
      <title id="title">${_('Rename')}</title>
      <use xlink:href="#edit" />
    </svg>
  </a>
  <a title="${_('Delete')}" href="${h.url(controller='logbook', action='deleteDocument', id=doc.id,
                   confirmed=0)}">
    <svg class="svg-icon svg-warning" aria-labelledby="title" role="img">
      <title id="title">${_('Delete')}</title>
      <use xlink:href="#delete" />
    </svg>
  </a>
% endif
</%def>


