## -*- coding: utf-8 -*-
<%inherit file="../main.mako" />
<%! import mpulsweb.lib.helper.filters as F %>
<%def name="buildNavipath()">
  ${parent.buildNavipath()}
  <li>
    <a href="${h.url(controller='settings')}">${_('Administration')}</a>
  </li>
  <li>
    <a href="${h.url(controller='settings', action='show')}">${_('Show settings')}</a>
  </li>
</%def>

<%def name="title()">
    ${h.get_app_title()} - ${_('adm_header_showsettings')}
</%def>

<div class="row">
  <div class="col-auto offset-1" id="content_ueberschrift">
    <h3>${_('adm_header_showsettings')}</h3>
  </div>
  <div class="col modusfield">
    <a title="${_('Edit settings')}" href="${h.url(controller='settings', action='edit')}">
      <svg class="svg-icon" aria-labelledby="title" role="img">
        <title id="title">${_('Edit settings')}</title>
        <use xlink:href="#edit" />
      </svg>
    </a>
  </div>
</div>

<div class="formularpage col-xl-9 offset-1">
  <p class="info-text">${_('Here you can see institution wide settings.')}</p>
  <div class="table-responsive">
    <table class="table table-sm table-borderless col-xl-8">
     <tr>
      <td>
        ${_('Name of the institution')}
      </td>
      <td>${c.agency.getName()| F.NA}
      </td>
    </tr>
    <tr>
      <td>
        ${_('Address of the institution')}
      </td>
      <td>${c.agency.getAddress()| F.NA}
      </td>
    </tr>
    <tr>
      <td>
      ${_('Automatic review after days')}</td>
      <td>${c.agency.getMaxSavetime()| F.NA}</td>
    </tr>
    <tr>
      <td>${_('additional conditions for reminders')}</td>
      <td>${h.literal(c.agency.getReminderConditionDesc())}</td>
    </tr>
    <tr>
      <td>${_('Assign case document')}</td>
      <td>
        % if c.agency.isAnonTransfer():
          ${_('Yes')}
        % else:
          ${_('No')}
        % endif
      </td>
    </tr>
   </table>
  </div>
</div>
