#!/usr/bin/python
# -*- coding: utf-8 -*-
import sys
import psycopg2

UPDATE_META_LOGIN = """\
UPDATE ka_konfiguration_tbl 
SET wert=%s WHERE bez='meta_user_name'"""

UPDATE_META_PASSWORD = """\
UPDATE ka_konfiguration_tbl 
SET wert=%s WHERE bez='meta_user_password'"""

SELECT_META_LOGIN = """\
SELECT wert FROM ka_konfiguration_tbl WHERE bez='meta_user_name'"""

SELECT_META_PASSWORD = """\
SELECT wert FROM ka_konfiguration_tbl WHERE bez='meta_user_password'"""

def set_login(app_db, app_port, login, password):
    con = None
    try:
        con = psycopg2.connect(database="ka_"+app_db +"_db", port=app_port)
        cur = con.cursor()
        if login:
            try:
                cur.execute(SELECT_META_LOGIN)
                old_login = cur.fetchone()[0]
                cur.execute(SELECT_META_PASSWORD)
                old_password = cur.fetchone()[0]
                #print ("Old login %s with password %s in app db %s" %
                #       (old_login, old_password, app_db))
                cur.execute(UPDATE_META_LOGIN, (login,))
                cur.execute(UPDATE_META_PASSWORD, (password,))
                #print ("Set meta login %s with password %s to application db %s"
                #        % (login, password, app_db))
                con.commit()
		print "%s login: %s -> %s, pass: %s -> %s" % (app_db, old_login, login, old_password, password)
                return (old_login, old_password)
            except psycopg2.DatabaseError, e:
                print "Can set meta user: %s" % e
    except psycopg2.DatabaseError, e:
        pass
	#print "Can not connect to %s" % app_db
    finally:
        if con:
            con.close()
    return (None, None)

def main():
    if not len(sys.argv) -1 == 2:
        print "set_meta_user.py <app port> <mapping2>"
        print "  set users in the application level"
        print "Not two argument -> exit"
        return
    app_port = sys.argv[1]
    mapping2 = open(sys.argv[2])
    app2user_pw_dict = eval(mapping2.read())
    mapping2.close()
    app2user_olduser_dict = {}
    print "Set meta_user info in application databases..."
    for app_db in app2user_pw_dict:
        (old_login, old_password) = set_login(app_db, app_port, 
                                              app2user_pw_dict[app_db][0],
                                              app2user_pw_dict[app_db][1])
        if old_login:
            app2user_olduser_dict[app_db] = (app2user_pw_dict[app_db][0],
                                             old_login)
    output = open("mapping3.txt", 'w+')
    output.write(repr(app2user_olduser_dict))
    output.close()
        
main()
