#!/bin/sh
set -e
set -x

TYPE=$1
PORT=${3:-5435}
DATE=${2:-`date +%Y-%m-%d`}
DB=ka_stkjsauswertung102_db

TRANSFERDIR=/home/mpuls/transfer-struktur
DATADIR=${TRANSFERDIR}/data/1000

ARCHIVDIR=/var/www/${TYPE}/archive 

IMPORTCOMMAND=$TRANSFERDIR/import-sqlite.py
IMPORTFILE=${TYPE}-${DATE}.db

echo =======================
echo START `date +'%Y-%m-%d %H:%M:%S'` on ${TRANSFERDIR}
echo =======================

# 1. Create a database

# 2. Import data

# 3. Copy data to archive

# Stop Webserver
#/etc/init.d/apache2 stop
## Copying data to archive 
echo "Copy to archive..."
#cp ${DATADIR}/${IMPORTFILE} ${ARCHIVDIR}
cd ${DATADIR}
#bunzip2 --keep ${IMPORTFILE}.bz2
bunzip2 ${IMPORTFILE}.bz2
chgrp postgres ${IMPORTFILE}
echo 'UPDATE master_tbl SET bearbeiter_id = 3;' | sqlite3 ${DATADIR}/${IMPORTFILE}

# Delete all cases
echo "Delete old data..."
sudo -u postgres psql -p ${PORT} ${DB} -c "TRUNCATE master_tbl CASCADE"
#
echo "Import new data..."
sudo -u postgres ${IMPORTCOMMAND} -i ${DATADIR}/${IMPORTFILE} -o $DB -p ${PORT} 
#sudo -u postgres python /home/mpuls/jmd/libmpuls/mpulstags.py -d ${DB} -p ${PORT}  /home/mpuls/jmd/releases/current/mpulsweb/default_tagging.xml
sudo -u postgres psql ${DB} -p ${PORT} -c "UPDATE master_tbl set bearbeiter_id = 3"

bzip2 ${IMPORTFILE}

echo =======================
echo END `date +'%Y-%m-%d %H:%M:%S'`
echo =======================
