#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Copyright 2012 Intevation GmbH, Germany, <info@intevation.de>
# Authors:
# Björn Ricks <bjoern.ricks@intevation.de>
#

import unittest

from formed.meta.lex import split

class TestShlex(unittest.TestCase):

    def test_shlex(self):
        self.assertEquals(split("\"a\""), ["\"a\""])
        self.assertEquals(split("\"a\" \"b\""), ["\"a\"", "\"b\""])
        self.assertEquals(split("\"a b\" \"c\""), ["\"a b\"", "\"c\""])
        self.assertEquals(split('a"b"'), ["a", "\"b\""])
        self.assertEquals(split('"a"b'), ["\"a\"", "b"])
        self.assertEquals(split("a\\\"b"), ["a\"b"])
        self.assertEquals(split("a\\\'b"), ["a\'b"])
        self.assertEquals(split('"a\\\"b"'), ["\"a\"b\""])
        self.assertEquals(split("'a\\\'b'"), ["\'a\'b\'"])


if __name__ == "__main__":
    unittest.main()
